Package: DelayedTensor
Type: Package
Title: R package for sparse and out-of-core arithmetic and
        decomposition of Tensor
Version: 1.19.0
Authors@R: c(person("Koki", "Tsuyuzaki", role = c("aut", "cre"),
                email = "k.t.the-answer@hotmail.co.jp"))
Depends: R (>= 4.1.0)
Imports: methods, utils, S4Arrays, SparseArray, DelayedArray (>=
        0.31.8), HDF5Array, BiocSingular, rTensor, DelayedRandomArray
        (>= 1.13.1), irlba, Matrix, einsum,
Suggests: markdown, rmarkdown, BiocStyle, knitr, testthat, magrittr,
        dplyr, reticulate
Description: DelayedTensor operates Tensor arithmetic directly on
    DelayedArray object. DelayedTensor provides some generic function related to
    Tensor arithmetic/decompotision and dispatches it on the DelayedArray class.
    DelayedTensor also suppors Tensor contraction by einsum function,
    which is inspired by numpy einsum.
License: Artistic-2.0
biocViews: Software, Infrastructure, DataRepresentation,
        DimensionReduction
LazyData: true
LazyDataCompression: xz
VignetteBuilder: knitr
BugReports: https://github.com/rikenbit/DelayedTensor/issues
git_url: https://git.bioconductor.org/packages/DelayedTensor
git_branch: devel
git_last_commit: ebd03f4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-29 21:22:06 UTC; biocbuild
Author: Koki Tsuyuzaki [aut, cre]
Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>

arrA <- array(runif(3), dim=c(3))
arrB <- array(runif(3), dim=c(3))
arrC <- array(runif(3*3), dim=c(3,3))
arrD <- array(runif(3*4), dim=c(3,4))
arrE <- array(runif(3*3*3), dim=c(3,3,3))
arrF <- array(runif(3*4*5), dim=c(3,4,5))
arrG <- array(runif(3*3*3*3), dim=c(3,3,3,3))
arrH <- array(runif(3*4*5*6), dim=c(3,4,5,6))

darrA <- DelayedArray(arrA)
darrB <- DelayedArray(arrB)
darrC <- DelayedArray(arrC)
darrD <- DelayedArray(arrD)
darrE <- DelayedArray(arrE)
darrF <- DelayedArray(arrF)
darrG <- DelayedArray(arrG)
darrH <- DelayedArray(arrH)

#
# einsum (sum + permutation)
#
# tmp1: einsum('ijk->i', arrF)
tmp1 <- rep(0, dim(arrF)[1])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp1[i] <- tmp1[i] + arrF[i,j,k]
		}
	}
}

# tmp2: einsum('ijk->j', arrF)
tmp2 <- rep(0, dim(arrF)[2])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp2[j] <- tmp2[j] + arrF[i,j,k]
		}
	}
}

# tmp3: einsum('ijk->k', arrF)
tmp3 <- rep(0, dim(arrF)[3])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp3[k] <- tmp3[k] + arrF[i,j,k]
		}
	}
}

# tmp4: einsum('ijk->ij', arrF)
tmp4 <- array(0, dim=dim(arrF)[c(1,2)])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp4[i,j] <- tmp4[i,j] + arrF[i,j,k]
		}
	}
}

# tmp5: einsum('ijk->jk', arrF)
tmp5 <- array(0, dim=dim(arrF)[c(2,3)])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp5[j,k] <- tmp5[j,k] + arrF[i,j,k]
		}
	}
}

# tmp6: einsum('ijk->ik', arrF)
tmp6 <- array(0, dim=dim(arrF)[c(1,3)])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp6[i,k] <- tmp6[i,k] + arrF[i,j,k]
		}
	}
}

# tmp7: einsum('ijkl->i', arrG)
tmp7 <- rep(0, length=dim(arrG)[1])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp7[i] <- tmp7[i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp8: einsum('ijkl->j', arrG)
tmp8 <- rep(0, length=dim(arrG)[2])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp8[j] <- tmp8[j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp9: einsum('ijkl->k', arrG)
tmp9 <- rep(0, length=dim(arrG)[3])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp9[k] <- tmp9[k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp10: einsum('ijkl->l', arrG)
tmp10 <- rep(0, length=dim(arrG)[4])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp10[l] <- tmp10[l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp11: einsum('ijkl->ij', arrG)
tmp11 <- array(0, dim=dim(arrG)[c(1,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp11[i,j] <- tmp11[i,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp12: einsum('ijkl->ik', arrG)
tmp12 <- array(0, dim=dim(arrG)[c(1,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp12[i,k] <- tmp12[i,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp13: einsum('ijkl->il', arrG)
tmp13 <- array(0, dim=dim(arrG)[c(1,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp13[i,l] <- tmp13[i,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp14: einsum('ijkl->ji', arrG)
tmp14 <- array(0, dim=dim(arrG)[c(2,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp14[j,i] <- tmp14[j,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp15: einsum('ijkl->jk', arrG)
tmp15 <- array(0, dim=dim(arrG)[c(2,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp15[j,k] <- tmp15[j,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp16: einsum('ijkl->jl', arrG)
tmp16 <- array(0, dim=dim(arrG)[c(2,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp16[j,l] <- tmp16[j,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp17: einsum('ijkl->ki', arrG)
tmp17 <- array(0, dim=dim(arrG)[c(3,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp17[k,i] <- tmp17[k,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp18: einsum('ijkl->kj', arrG)
tmp18 <- array(0, dim=dim(arrG)[c(3,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp18[k,j] <- tmp18[k,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp19: einsum('ijkl->kl', arrG)
tmp19 <- array(0, dim=dim(arrG)[c(3,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp19[k,l] <- tmp19[k,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp20: einsum('ijkl->li', arrG)
tmp20 <- array(0, dim=dim(arrG)[c(4,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp20[l,i] <- tmp20[l,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp21: einsum('ijkl->lj', arrG)
tmp21 <- array(0, dim=dim(arrG)[c(4,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp21[l,j] <- tmp21[l,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp22: einsum('ijkl->lk', arrG)
tmp22 <- array(0, dim=dim(arrG)[c(4,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp22[l,k] <- tmp22[l,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp23: einsum('ijkl->ijk', arrG)
tmp23 <- array(0, dim=dim(arrG)[c(1,2,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp23[i,j,k] <- tmp23[i,j,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp24: einsum('ijkl->ijl', arrG)
tmp24 <- array(0, dim=dim(arrG)[c(1,2,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp24[i,j,l] <- tmp24[i,j,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp25: einsum('ijkl->ikj', arrG)
tmp25 <- array(0, dim=dim(arrG)[c(1,3,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp25[i,k,j] <- tmp25[i,k,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp26: einsum('ijkl->ikl', arrG)
tmp26 <- array(0, dim=dim(arrG)[c(1,3,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp26[i,k,l] <- tmp26[i,k,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp27: einsum('ijkl->ilj', arrG)
tmp27 <- array(0, dim=dim(arrG)[c(1,4,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp27[i,l,j] <- tmp27[i,l,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp28: einsum('ijkl->ilk', arrG)
tmp28 <- array(0, dim=dim(arrG)[c(1,4,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp28[i,l,k] <- tmp28[i,l,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp29: einsum('ijkl->jik', arrG)
tmp29 <- array(0, dim=dim(arrG)[c(2,1,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp29[j,i,k] <- tmp29[j,i,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp30: einsum('ijkl->jil', arrG)
tmp30 <- array(0, dim=dim(arrG)[c(2,1,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp30[j,i,l] <- tmp30[j,i,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp31: einsum('ijkl->jki', arrG)
tmp31 <- array(0, dim=dim(arrG)[c(2,3,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp31[j,k,i] <- tmp31[j,k,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp32: einsum('ijkl->jkl', arrG)
tmp32 <- array(0, dim=dim(arrG)[c(2,3,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp32[j,k,l] <- tmp32[j,k,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp33: einsum('ijkl->jli', arrG)
tmp33 <- array(0, dim=dim(arrG)[c(2,4,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp33[j,l,i] <- tmp33[j,l,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp34: einsum('ijkl->jlk', arrG)
tmp34 <- array(0, dim=dim(arrG)[c(2,4,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp34[j,l,k] <- tmp34[j,l,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp35: einsum('ijkl->kij', arrG)
tmp35 <- array(0, dim=dim(arrG)[c(3,1,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp35[k,i,j] <- tmp35[k,i,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp36: einsum('ijkl->kil', arrG)
tmp36 <- array(0, dim=dim(arrG)[c(3,1,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp36[k,i,l] <- tmp36[k,i,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp37: einsum('ijkl->kji', arrG)
tmp37 <- array(0, dim=dim(arrG)[c(3,2,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp37[k,j,i] <- tmp37[k,j,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp38: einsum('ijkl->kjl', arrG)
tmp38 <- array(0, dim=dim(arrG)[c(3,2,4)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp38[k,j,l] <- tmp38[k,j,l] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp39: einsum('ijkl->kli', arrG)
tmp39 <- array(0, dim=dim(arrG)[c(3,4,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp39[k,l,i] <- tmp39[k,l,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp40: einsum('ijkl->klj', arrG)
tmp40 <- array(0, dim=dim(arrG)[c(3,4,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp40[k,l,j] <- tmp40[k,l,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp41: einsum('ijkl->lij', arrG)
tmp41 <- array(0, dim=dim(arrG)[c(4,1,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp41[l,i,j] <- tmp41[l,i,j] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp42: einsum('ijkl->lik', arrG)
tmp42 <- array(0, dim=dim(arrG)[c(4,1,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp42[l,i,k] <- tmp42[l,i,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp43: einsum('ijkl->lji', arrG)
tmp43 <- array(0, dim=dim(arrG)[c(4,2,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp43[l,j,i] <- tmp43[l,j,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp44: einsum('ijkl->ljk', arrG)
tmp44 <- array(0, dim=dim(arrG)[c(4,2,3)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp44[l,j,k] <- tmp44[l,j,k] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp45: einsum('ijkl->lki', arrG)
tmp45 <- array(0, dim=dim(arrG)[c(4,3,1)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp45[l,k,i] <- tmp45[l,k,i] + arrG[i,j,k,l]
			}
		}
	}
}

# tmp46: einsum('ijkl->lkj', arrG)
tmp46 <- array(0, dim=dim(arrG)[c(4,3,2)])
for(i in 1:dim(arrG)[1]){
	for(j in 1:dim(arrG)[2]){
		for(k in 1:dim(arrG)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp46[l,k,j] <- tmp46[l,k,j] + arrG[i,j,k,l]
			}
		}
	}
}

#
# einsum (multiply, diagonal)
#
# tmp47: einsum('iii->i', arrE)
tmp47 <- rep(0, dim(arrE)[1])
for(i in 1:dim(arrE)[1]){
	tmp47[i] <- tmp47[i] + arrE[i,i,i]
}

# tmp48: einsum('iiii->i', arrG)
tmp48 <- rep(0, dim(arrG)[1])
for(i in 1:dim(arrG)[1]){
	tmp48[i] <- tmp48[i] + arrG[i,i,i,i]
}

#
# einsum (sum + multiply + transpose)
#
# tmp49: einsum('ij,jk->j', arrC, arrD)
tmp49 <- rep(0, dim(arrC)[2])
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp49[j] <- tmp49[j] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp50: einsum('ij,jk->ij', arrC, arrD))
tmp50 <- array(0, dim=c(dim(arrC)[1], dim(arrC)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp50[i,j] <- tmp50[i,j] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp51: einsum('ij,jk->ji', arrC, arrD))
tmp51 <- array(0, dim=c(dim(arrC)[2], dim(arrC)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp51[j,i] <- tmp51[j,i] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp52: einsum('ij,jk->jk', arrC, arrD))
tmp52 <- array(0, dim=c(dim(arrC)[2], dim(arrD)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp52[j,k] <- tmp52[j,k] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp53: einsum('ij,jk->kj', arrC, arrD))
tmp53 <- array(0, dim=c(dim(arrD)[2], dim(arrD)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp53[k,j] <- tmp53[k,j] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp54: einsum('ij,jk->ik', arrC, arrD))
tmp54 <- array(0, dim=c(dim(arrC)[1], dim(arrD)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp54[i,k] <- tmp54[i,k] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp55: einsum('ij,jk->ki', arrC, arrD))
tmp55 <- array(0, dim=c(dim(arrD)[2], dim(arrC)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp55[k,i] <- tmp55[k,i] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp56: einsum('ij,jk->ijk', arrC, arrD))
tmp56 <- array(0, dim=c(dim(arrC)[1], dim(arrC)[2], dim(arrD)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp56[i,j,k] <- tmp56[i,j,k] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp57: einsum('ij,jk->ikj', arrC, arrD))
tmp57 <- array(0, dim=c(dim(arrC)[1], dim(arrD)[2], dim(arrD)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp57[i,k,j] <- tmp57[i,k,j] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp58: einsum('ij,jk->jik', arrC, arrD))
tmp58 <- array(0, dim=c(dim(arrC)[2], dim(arrC)[1], dim(arrD)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp58[j,i,k] <- tmp58[j,i,k] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp59: einsum('ij,jk->jki', arrC, arrD))
tmp59 <- array(0, dim=c(dim(arrC)[2], dim(arrD)[2], dim(arrC)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp59[j,k,i] <- tmp59[j,k,i] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp60: einsum('ij,jk->kij', arrC, arrD))
tmp60 <- array(0, dim=c(dim(arrD)[2], dim(arrC)[1], dim(arrC)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp60[k,i,j] <- tmp60[k,i,j] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp61: einsum('ij,jk->kji', arrC, arrD))
tmp61 <- array(0, dim=c(dim(arrD)[2], dim(arrC)[2], dim(arrC)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrD)[2]){
			tmp61[k,j,i] <- tmp61[k,j,i] + arrC[i,j] * arrD[j,k]
		}
	}
}

# tmp62: einsum('ij,ijk->', arrC, arrE))
tmp62 <- 0
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp62 <- tmp62 + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp63: einsum('ij,ijk->i', arrC, arrE))
tmp63 <- rep(0, dim(arrC)[1])
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp63[i] <- tmp63[i] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp64: einsum('ij,ijk->j', arrC, arrE))
tmp64 <- rep(0, dim(arrC)[2])
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp64[j] <- tmp64[j] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp65: einsum('ij,ijk->k', arrC, arrE))
tmp65 <- rep(0, dim(arrE)[2])
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp65[k] <- tmp65[k] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp66: einsum('ij,ijk->ij', arrC, arrE))
tmp66 <- array(0, dim=c(dim(arrC)[1], dim(arrC)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp66[i,j] <- tmp66[i,j] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp67: einsum('ij,ijk->ji', arrC, arrE))
tmp67 <- array(0, dim=c(dim(arrC)[2], dim(arrC)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp67[j,i] <- tmp67[j,i] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp68: einsum('ij,ijk->jk', arrC, arrE))
tmp68 <- array(0, dim=c(dim(arrC)[2], dim(arrE)[3]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp68[j,k] <- tmp68[j,k] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp69: einsum('ij,ijk->kj', arrC, arrE))
tmp69 <- array(0, dim=c(dim(arrE)[3], dim(arrC)[2]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp69[k,j] <- tmp69[k,j] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp70: einsum('ij,ijk->ik', arrC, arrE))
tmp70 <- array(0, dim=c(dim(arrC)[1], dim(arrE)[3]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp70[i,k] <- tmp70[i,k] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp71: einsum('ij,ijk->ki', arrC, arrE))
tmp71 <- array(0, dim=c(dim(arrE)[3], dim(arrC)[1]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp71[k,i] <- tmp71[k,i] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp72: einsum('ij,ijk->ijk', arrC, arrE))
tmp72 <- array(0, dim=c(dim(arrC)[1], dim(arrC)[2], dim(arrE)[3]))
for(i in 1:dim(arrC)[1]){
	for(j in 1:dim(arrC)[2]){
		for(k in 1:dim(arrE)[2]){
			tmp72[i,j,k] <- tmp72[i,j,k] + arrC[i,j] * arrE[i,j,k]
		}
	}
}

# tmp73: einsum('ijk,ijkl->', arrE, arrG))
tmp73 <- 0
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp73 <- tmp73 + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp74: einsum('ijk,ijkl->i', arrE, arrG))
tmp74 <- rep(0, dim(arrE)[1])
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp74[i] <- tmp74[i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp75: einsum('ijk,ijkl->j', arrE, arrG))
tmp75 <- rep(0, dim(arrE)[2])
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp75[j] <- tmp75[j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp76: einsum('ijk,ijkl->k', arrE, arrG))
tmp76 <- rep(0, dim(arrE)[3])
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp76[k] <- tmp76[k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp77: einsum('ijk,ijkl->l', arrE, arrG))
tmp77 <- rep(0, dim(arrG)[4])
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp77[l] <- tmp77[l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp78: einsum('ijk,ijkl->ij', arrE, arrG))
tmp78 <- array(0, dim=c(dim(arrE)[1], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp78[i,j] <- tmp78[i,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp79: einsum('ijk,ijkl->ji', arrE, arrG))
tmp79 <- array(0, dim=c(dim(arrE)[2], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp79[j,i] <- tmp79[j,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp80: einsum('ijk,ijkl->ik', arrE, arrG))
tmp80 <- array(0, dim=c(dim(arrE)[1], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp80[i,k] <- tmp80[i,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp81: einsum('ijk,ijkl->ki', arrE, arrG))
tmp81 <- array(0, dim=c(dim(arrE)[3], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp81[k,i] <- tmp81[k,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp82: einsum('ijk,ijkl->il', arrE, arrG))
tmp82 <- array(0, dim=c(dim(arrE)[1], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp82[i,l] <- tmp82[i,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp83: einsum('ijk,ijkl->li', arrE, arrG))
tmp83 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp83[l,i] <- tmp83[l,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp84: einsum('ijk,ijkl->jk', arrE, arrG))
tmp84 <- array(0, dim=c(dim(arrE)[2], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp84[j,k] <- tmp84[j,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp85: einsum('ijk,ijkl->kj', arrE, arrG))
tmp85 <- array(0, dim=c(dim(arrE)[3], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp85[k,j] <- tmp85[k,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp86: einsum('ijk,ijkl->jl', arrE, arrG))
tmp86 <- array(0, dim=c(dim(arrE)[2], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp86[j,l] <- tmp86[j,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp87: einsum('ijk,ijkl->lj', arrE, arrG))
tmp87 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp87[l,j] <- tmp87[l,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp88: einsum('ijk,ijkl->kl', arrE, arrG))
tmp88 <- array(0, dim=c(dim(arrE)[3], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp88[k,l] <- tmp88[k,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp89: einsum('ijk,ijkl->lk', arrE, arrG))
tmp89 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp89[l,k] <- tmp89[l,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp90: einsum('ijk,ijkl->ijk', arrE, arrG))
tmp90 <- array(0, dim=c(dim(arrE)[1], dim(arrE)[2], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp90[i,j,k] <- tmp90[i,j,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp91: einsum('ijk,ijkl->ikj', arrE, arrG))
tmp91 <- array(0, dim=c(dim(arrE)[1], dim(arrE)[3], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp91[i,k,j] <- tmp91[i,k,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp92: einsum('ijk,ijkl->jik', arrE, arrG))
tmp92 <- array(0, dim=c(dim(arrE)[2], dim(arrE)[1], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp92[j,i,k] <- tmp92[j,i,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp93: einsum('ijk,ijkl->jki', arrE, arrG))
tmp93 <- array(0, dim=c(dim(arrE)[2], dim(arrE)[3], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp93[j,k,i] <- tmp93[j,k,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp94: einsum('ijk,ijkl->kij', arrE, arrG))
tmp94 <- array(0, dim=c(dim(arrE)[3], dim(arrE)[1], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp94[k,i,j] <- tmp94[k,i,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp95: einsum('ijk,ijkl->kji', arrE, arrG))
tmp95 <- array(0, dim=c(dim(arrE)[3], dim(arrE)[2], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp95[k,j,i] <- tmp95[k,j,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp96: einsum('ijk,ijkl->ijl', arrE, arrG))
tmp96 <- array(0, dim=c(dim(arrE)[1], dim(arrE)[2], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp96[i,j,l] <- tmp96[i,j,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp97: einsum('ijk,ijkl->ilj', arrE, arrG))
tmp97 <- array(0, dim=c(dim(arrE)[1], dim(arrG)[4], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp97[i,l,j] <- tmp97[i,l,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp98: einsum('ijk,ijkl->jil', arrE, arrG))
tmp98 <- array(0, dim=c(dim(arrE)[2], dim(arrE)[1], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp98[j,i,l] <- tmp98[j,i,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp99: einsum('ijk,ijkl->jli', arrE, arrG))
tmp99 <- array(0, dim=c(dim(arrE)[2], dim(arrG)[4], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp99[j,l,i] <- tmp99[j,l,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp100: einsum('ijk,ijkl->lij', arrE, arrG))
tmp100 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[1], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp100[l,i,j] <- tmp100[l,i,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp101: einsum('ijk,ijkl->lji', arrE, arrG))
tmp101 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[2], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp101[l,j,i] <- tmp101[l,j,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp102: einsum('ijk,ijkl->ikl', arrE, arrG))
tmp102 <- array(0, dim=c(dim(arrE)[1], dim(arrE)[3], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp102[i,k,l] <- tmp102[i,k,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp103: einsum('ijk,ijkl->ilk', arrE, arrG))
tmp103 <- array(0, dim=c(dim(arrE)[1], dim(arrG)[4], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp103[i,l,k] <- tmp103[i,l,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp104: einsum('ijk,ijkl->kil', arrE, arrG))
tmp104 <- array(0, dim=c(dim(arrE)[3], dim(arrE)[1], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp104[k,i,l] <- tmp104[k,i,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp105: einsum('ijk,ijkl->kli', arrE, arrG))
tmp105 <- array(0, dim=c(dim(arrE)[3], dim(arrG)[4], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp105[k,l,i] <- tmp105[k,l,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp106: einsum('ijk,ijkl->lik', arrE, arrG))
tmp106 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[1], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp106[l,i,k] <- tmp106[l,i,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp107: einsum('ijk,ijkl->lki', arrE, arrG))
tmp107 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[3], dim(arrE)[1]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp107[l,k,i] <- tmp107[l,k,i] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp108: einsum('ijk,ijkl->jkl', arrE, arrG))
tmp108 <- array(0, dim=c(dim(arrE)[2], dim(arrE)[3], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp108[j,k,l] <- tmp108[j,k,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp109: einsum('ijk,ijkl->jlk', arrE, arrG))
tmp109 <- array(0, dim=c(dim(arrE)[2], dim(arrG)[4], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp109[j,l,k] <- tmp109[j,l,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp110: einsum('ijk,ijkl->kjl', arrE, arrG))
tmp110 <- array(0, dim=c(dim(arrE)[3], dim(arrE)[2], dim(arrG)[4]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp110[k,j,l] <- tmp110[k,j,l] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp111: einsum('ijk,ijkl->klj', arrE, arrG))
tmp111 <- array(0, dim=c(dim(arrE)[3], dim(arrG)[4], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp111[k,l,j] <- tmp111[k,l,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp112: einsum('ijk,ijkl->ljk', arrE, arrG))
tmp112 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[2], dim(arrE)[3]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp112[l,j,k] <- tmp112[l,j,k] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

# tmp113: einsum('ijk,ijkl->lkj', arrE, arrG))
tmp113 <- array(0, dim=c(dim(arrG)[4], dim(arrE)[3], dim(arrE)[2]))
for(i in 1:dim(arrE)[1]){
	for(j in 1:dim(arrE)[2]){
		for(k in 1:dim(arrE)[3]){
			for(l in 1:dim(arrG)[4]){
				tmp113[l,k,j] <- tmp113[l,k,j] + arrE[i,j,k] * arrG[i,j,k,l]
			}
		}
	}
}

#
# einsum (sum + multiply + transpose, three tensor)
#
# tmp114: einsum('i,ij,ijk->', arrA, arrD, arrF)
tmp114 <- 0
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp114 <- tmp114 + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp115: einsum('i,ij,ijk->i', arrA, arrD, arrF)
tmp115 <- rep(0, dim(arrF)[1])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp115[i] <- tmp115[i] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp116: einsum('i,ij,ijk->j', arrA, arrD, arrF)
tmp116 <- rep(0, dim(arrF)[2])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp116[j] <- tmp116[j] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp117: einsum('i,ij,ijk->k', arrA, arrD, arrF)
tmp117 <- rep(0, dim(arrF)[3])
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp117[k] <- tmp117[k] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp118: einsum('i,ij,ijk->ij', arrA, arrD, arrF)
tmp118 <- array(0, dim=c(dim(arrF)[1], dim(arrF)[2]))
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp118[i,j] <- tmp118[i,j] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp119: einsum('i,ij,ijk->ik', arrA, arrD, arrF)
tmp119 <- array(0, dim=c(dim(arrF)[1], dim(arrF)[3]))
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp119[i,k] <- tmp119[i,k] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp120: einsum('i,ij,ijk->ji', arrA, arrD, arrF)
tmp120 <- array(0, dim=c(dim(arrF)[2], dim(arrF)[1]))
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp120[j,i] <- tmp120[j,i] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp121: einsum('i,ij,ijk->jk', arrA, arrD, arrF)
tmp121 <- array(0, dim=c(dim(arrF)[2], dim(arrF)[3]))
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp121[j,k] <- tmp121[j,k] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp122: einsum('i,ij,ijk->ki', arrA, arrD, arrF)
tmp122 <- array(0, dim=c(dim(arrF)[3], dim(arrF)[1]))
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp122[k,i] <- tmp122[k,i] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp123: einsum('i,ij,ijk->kj', arrA, arrD, arrF)
tmp123 <- array(0, dim=c(dim(arrF)[3], dim(arrF)[2]))
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp123[k,j] <- tmp123[k,j] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp124: einsum('i,ij,ijk->ijk', arrA, arrD, arrF)
tmp124 <- array(0, dim=c(dim(arrF)[1], dim(arrF)[2], dim(arrF)[3]))
for(i in 1:dim(arrF)[1]){
	for(j in 1:dim(arrF)[2]){
		for(k in 1:dim(arrF)[3]){
			tmp124[i,j,k] <- tmp124[i,j,k] + arrA[i] * arrD[i,j] * arrF[i,j,k]
		}
	}
}

# tmp125: einsum('i,ij,ijk,ijkl->ijkl', arrA, arrD, arrF, arrH)
tmp125 <- array(0, dim=dim(arrH))
for(i in 1:dim(arrH)[1]){
	for(j in 1:dim(arrH)[2]){
		for(k in 1:dim(arrH)[3]){
			for(l in 1:dim(arrH)[4]){
				tmp125[i,j,k,l] <- tmp125[i,j,k,l] + arrA[i] * arrD[i,j] * arrF[i,j,k] * arrH[i,j,k,l]
			}
		}
	}
}

.onLoad <- function(libname, pkgname){
    options(delayedtensor.sparse = FALSE) # Suppressing Experimental Mode
    options(delayedtensor.verbose = FALSE)
    setHDF5DumpChunkLength(length = 100000L)
    setHDF5DumpCompressionLevel(level = 0L)
}

#
# Functions that operateon Matrices and Arrays
#
# list_rep
list_rep <- function(x, n=NULL){
    lapply(seq_len(n), function(a){x})
}

# modebind_list
modebind_list <- function(L, m=NULL){
    # Argument check
    .checkModeBindList(L, m)
    # Setting
    num_modes <- .ndim(L[[1]])
    l <- length(L)
    m_modes <- unlist(lapply(L, function(x,m){dim(x)[m]}, m=m))
    new_modes <- as.integer(dim(L[[1]]))
    new_modes[m] <- sum(m_modes)
    new_modes <- as.integer(new_modes)
    # Vectorization
    Lvec <- lapply(L, function(x){vec(x)})
    cmd <- paste0("Lvec <- rbind(",
        paste(paste0("Lvec[[", seq_len(l), "]]"), collapse=","),
        ")")
    eval(parse(text=cmd))
    Lvec <- .realize_and_return(Lvec)
    Lvec <- .reshapeIncNumbers1D(Lvec, new_modes)
    .realize_and_return(Lvec)
}

# rbind_list
rbind_list <- function(L){
    lapply(L, .check2D)
    modebind_list(L, m=1)
}

# cbind_list
cbind_list <- function(L){
    lapply(L, .check2D)
    modebind_list(L, m=2)
}

# hadamard_list
hadamard_list <- function(L){
    # Argument check
    stopifnot(is.list(L))
    lapply(L, .checkDelayedArray)
    retmat <- L[[1]]
    for(i in 2:length(L)){
        retmat <- .hadamard(retmat, L[[i]])
    }
    as(retmat, "DelayedArray")
}

# kronecker_list
kronecker_list <- function(L){
    # Argument check
    stopifnot(is.list(L))
    lapply(L, .checkDelayedArray)
    retmat <- L[[1]]
    for(i in 2:length(L)){
        retmat <- .kronecker(retmat, L[[i]])
    }
    as(retmat, "DelayedArray")
}

# khatri_rao_list
khatri_rao_list <- function(L, reverse=FALSE){
    # Argument check
    stopifnot(is.list(L))
    stopifnot(is.logical(reverse))
    lapply(L, .checkDelayedArray)
    ncols <- unlist(lapply(L, ncol))
    stopifnot(length(unique(ncols)) == 1)
    if(reverse){
        L <- rev(L)
    }
    retmat <- L[[1]]
    for(i in 2:length(L)){
        retmat <- .khatri_rao(retmat, L[[i]])
    }
    as(retmat, "DelayedArray")
}

# ttl
ttl <- function(darr, list_mat, ms=NULL){
    # Argument Check
    .checkDelayedArray(darr)
    lapply(list_mat, .checkDelayedArray)
    stopifnot(is.list(list_mat))
    if(is.null(ms) || !is.vector(ms)){
        stop ("m modes must be specified as a vector")
    }
    if(length(ms) != length(list_mat)){
        stop("m modes length does not match list_mat length")
    }
    num_mats <- length(list_mat)
    if(length(unique(ms)) != num_mats){
        warning("consider pre-multiplying matrices for the same m for speed")
    }

    # Setting
    mat_nrows <- vector("list", num_mats)
    mat_ncols <- vector("list", num_mats)
    out <- darr
    for(i in seq_len(num_mats)){
        mat <- as(list_mat[[i]], "DelayedMatrix")
        m <- ms[i]
        modes_in <- dim(out)
        mat_dims <- dim(mat)
        stopifnot(modes_in[m] == mat_dims[2])
        modes_out <- modes_in
        modes_out[m] <- mat_dims[1]
        out_m <- .rs_unfold(out, m=m)
        retarr_m <- .realize_and_return(mat %*% out_m)
        out <- .rs_fold(retarr_m, m=m, modes=modes_out)
    }
    out
}

# diag as Constructor
DelayedDiagonalArray <- function(shape, value){
    # Argument Check
    stopifnot(is.vector(shape))
    # Setting
    num_modes <- length(shape)
    min.s <- min(shape)
    if(missing(value)){
        value <- rep(1L, num_modes)
    }
    out <- COO_SparseArray(shape)
    out@nzdata <- as.vector(value)
    out@nzcoo <-  t(vapply(seq_len(min.s),
        function(x){rep(x, num_modes)}, rep(1L, num_modes)))
    DelayedArray(out)
}

# Ref
# https://github.com/rikenbit/rTensor/blob/master/R/rTensor_Misc.R

# Setting
# arr <- array(runif(3*4*5), dim=c(3,4,5))
# tnsr <- as.tensor(arr)
# darr <- DelayedArray(arr)
faces_tnsr <- load_orl()
subject <- faces_tnsr[,,21,]
dsubject <- DelayedArray(faces_tnsr[,,21,]@data)
# faces_tnsr <- array(runif(10*20*30*10), dim=c(10,20,30,10))
# subject <- as.tensor(faces_tnsr[,,21,])
# dsubject <- DelayedArray(faces_tnsr[,,21,])

# # visual confirmation
# png(file="GrandTruth.png")
# image(subject@data[,,1])
# dev.off()

context("### hosvd ###\n")
set.seed(1234)
hosvdD <- rTensor::hosvd(subject, ranks=c(10,10,10))
set.seed(1234)
dhosvdD <- hosvd(dsubject, ranks=c(10,10,10))

expect_equal(
    dim(hosvdD$Z@data),
    dim(dhosvdD$Z))
expect_equal(
    lapply(hosvdD$U, dim),
    lapply(dhosvdD$U, dim))
expect_equal(
    dim(hosvdD$est@data),
    dim(dhosvdD$est))
expect_true(abs(hosvdD$fnorm_resid - dhosvdD$fnorm_resid) <= 0.1)

# # visual confirmation
# png(file="HOSVD.png")
# image(hosvdD$est@data[,,1])
# dev.off()
# png(file="HOSVD_DelayedTensor.png")
# image(as.array(dhosvdD$est)[,,1])
# dev.off()

context("### cp ###\n")
set.seed(1234)
cpD <- rTensor::cp(subject, num_components=10, max_iter=20)
set.seed(1234)
dcpD <- cp(dsubject, num_components=10, max_iter=20)

expect_equal(
    length(cpD$lambdas),
    length(dcpD$lambdas))
expect_equal(
    lapply(cpD$U, dim),
    lapply(dcpD$U, dim))
expect_equal(
    dim(cpD$est),
    dim(dcpD$est))
expect_equal(
    cpD$norm_percent >= 0,
    dcpD$norm_percent >= 0)
l <- min(length(cpD$all_resid), length(dcpD$all_resid))
expect_equal(
    order(cpD$all_resid[seq(l)]),
    order(dcpD$all_resid[seq(l)]))
expect_true(abs(cpD$fnorm_resid - dcpD$fnorm_resid) <= 1)

# # visual confirmation
# core <- array(0, dim=rep(length(cpD$lambdas), 3))
# for(i in seq_along(cpD$lambdas)){
#     core[i,i,i] <- cpD$lambdas[i]
# }
# dcore <- DelayedArray(core)
# png(file="CP.png")
# image(cpD$est@data[,,1])
# dev.off()
# png(file="CP_DelayedTensor.png")
# image(as.array(dcpD$est)[,,1])
# dev.off()

context("### tucker ###\n")
set.seed(1234)
tuckerD <- rTensor::tucker(subject, ranks=c(10,10,10), max_iter=20)
set.seed(1234)
dtuckerD <- tucker(dsubject, ranks=c(10,10,10), max_iter=20)
expect_equal(
    dim(tuckerD$Z),
    dim(dtuckerD$Z)
)
expect_equal(
    lapply(tuckerD$U, dim),
    lapply(dtuckerD$U, dim)
)
expect_equal(
    tuckerD$conv,
    dtuckerD$conv
)
expect_equal(
    dim(tuckerD$est),
    dim(dtuckerD$est)
)
expect_equal(
    tuckerD$norm_percent >= 0,
    dtuckerD$norm_percent >= 0
)
l <- min(length(tuckerD$all_resid), length(dtuckerD$all_resid))
expect_equal(
    order(tuckerD$all_resid[seq(l)]),
    order(dtuckerD$all_resid[seq(l)]))
expect_true(abs(tuckerD$fnorm_resid - dtuckerD$fnorm_resid) <= 0.1)

# # visual confirmation
# png(file="TUCKER.png")
# image(tuckerD$est@data[,,1])
# dev.off()
# png(file="TUCKER_DelayedTensor.png")
# image(as.array(dtuckerD$est)[,,1])
# dev.off()

context("### mpca ###\n")
options(warn=-1)
set.seed(1234)
mpcaD <- rTensor::mpca(subject, ranks=c(10,10), max_iter=20)
set.seed(1234)
dmpcaD <- mpca(dsubject, ranks=c(10,10), max_iter=20)
options(warn=1)
expect_equal(
    mpcaD$conv,
    dmpcaD$conv
)
expect_equal(
    mpcaD$norm_percent >= 0,
    dmpcaD$norm_percent >= 0
)
l <- min(length(mpcaD$all_resid), length(dmpcaD$all_resid))
expect_equal(
    order(mpcaD$all_resid[seq(l)]),
    order(dmpcaD$all_resid[seq(l)]))
expect_true(abs(mpcaD$fnorm_resid - dmpcaD$fnorm_resid) <= 0.1)

# # visual confirmation
# png(file="MPCA.png")
# image(rTensor::ttl(mpcaD$Z_ext, mpcaD$U[1:2], ms=1:2)@data[,,1])
# dev.off()
# png(file="MPCA_DelayedTensor.png")
# image(as.array(ttl(dmpcaD$Z_ext, dmpcaD$U[1:2], ms=1:2))[,,1])
# dev.off()

context("### pvd ###\n")
set.seed(1234)
pvdD <- rTensor::pvd(subject, uranks=rep(5,10), wranks=rep(8,10), a=5, b=8)
set.seed(1234)
dpvdD <- pvd(dsubject, uranks=rep(5,10), wranks=rep(8,10), a=5, b=8)
expect_equal(
    dim(pvdD$P),
    dim(dpvdD$P)
)
expect_equal(
    dim(pvdD$D),
    dim(dpvdD$D)
)
expect_equal(
    dim(pvdD$V),
    dim(dpvdD$V)
)
expect_equal(
    dim(pvdD$est),
    dim(dpvdD$est)
)
expect_equal(
    pvdD$norm_percent >= 0,
    dpvdD$norm_percent >= 0
)
expect_true(abs(pvdD$fnorm_resid - dpvdD$fnorm_resid) <= 1)

# # visual confirmation
# png(file="PVD.png")
# image(pvdD$P %*% pvdD$V[[1]] %*% pvdD$D)
# dev.off()
# png(file="PVD_DelayedTensor.png")
# image(as.array(dpvdD$P %*% dpvdD$V[[1]] %*% dpvdD$D))
# dev.off()

context("### .is_zero_tensor ###\n")
expect_equal(
	rTensor:::.is_zero_tensor(tnsr),
	.is_zero_tensor(darr))

# Setting
lizt <- list(
    'mat1' = matrix(1:6, ncol=2),
    'mat2' = matrix(7:12, ncol=2),
    'mat3' = matrix(13:18, ncol=2))
lizt2 <- list(
    'mat1' = matrix(runif(30), ncol=3),
    'mat2' = matrix(runif(40), ncol=4),
    'mat3' = matrix(runif(50), ncol=5))
dlizt <- list(
    'mat1' = DelayedArray(lizt$mat1),
    'mat2' = DelayedArray(lizt$mat2),
    'mat3' = DelayedArray(lizt$mat3))
dlizt2 <- list(
    'mat1' = DelayedArray(lizt2$mat1),
    'mat2' = DelayedArray(lizt2$mat2),
    'mat3' = DelayedArray(lizt2$mat3))
set.seed(1234)
tnsr <- new("Tensor", 3L, c(3L, 4L, 5L), data=runif(60))
darr <- DelayedArray(tnsr@data)
mat <- matrix(runif(50), nrow=10, ncol=5)

context("### list_rep ###\n")
expect_equal(
    list_rep(tnsr, 3),
    list(tnsr, tnsr, tnsr))

context("### modebind_list/rbind_list ###\n")
expect_equal(
    as.array(rbind(dlizt[[1]], dlizt[[2]], dlizt[[3]])),
    as.array(modebind_list(dlizt, m=1)),
    as.array(rbind_list(dlizt)))

context("### modebind_list/cbind_list ###\n")
expect_equal(
    as.array(cbind(dlizt[[1]], dlizt[[2]], dlizt[[3]])),
    as.array(modebind_list(dlizt, m=2)),
    as.array(cbind_list(dlizt)))

context("### hadamard_list ###\n")
expect_equal(
    rTensor::hadamard_list(lizt),
    as.array(hadamard_list(dlizt)))

context("### kronecker_list ###\n")
expect_equal(
    rTensor::kronecker_list(lizt),
    as.array(kronecker_list(dlizt)))

context("### khatori_rao_list ###\n")
expect_equal(
    rTensor::khatri_rao_list(lizt, reverse=FALSE),
    as.array(khatri_rao_list(dlizt, reverse=FALSE)))
expect_equal(
    rTensor::khatri_rao_list(lizt, reverse=TRUE),
    as.array(khatri_rao_list(dlizt, reverse=TRUE)))

context("### ttl ###\n")
expect_equal(
    rTensor::ttl(tnsr, lizt2, ms=c(1,2,3))@data,
    as.array(ttl(darr, dlizt2, ms=c(1,2,3))))

context("### DelayedDiagonalArray ###\n")
E <- DelayedDiagonalArray(c(3,4,5))
expect_equal(E[1,1,1], 1)
expect_equal(E[2,2,2], 1)
expect_equal(E[3,3,3], 1)
expect_equal(E[3,4,5], 0)

F <- DelayedDiagonalArray(c(3,4,5), 1:3)
expect_equal(F[1,1,1], 1)
expect_equal(F[2,2,2], 2)
expect_equal(F[3,3,3], 3)
expect_equal(F[3,4,5], 0)

# Setting
arr4 <- array(runif(2*3*4*5), dim=c(2,3,4,5))
tnsr4 <- as.tensor(arr4)
darr4 <- DelayedArray(arr4)

# AllGenerics.R
context("### unfold ###")
print("unfold")
expect_equal(
    rTensor::unfold(tnsr4, row_idx=1, col_idx=c(2, 3, 4))@data,
    as.array(unfold(darr4, row_idx=1, col_idx=c(2, 3, 4))))
expect_equal(
    rTensor::unfold(tnsr4, row_idx=1, col_idx=c(2, 4, 3))@data,
    as.array(unfold(darr4, row_idx=1, col_idx=c(2, 4, 3))))
expect_equal(
    rTensor::unfold(tnsr4, row_idx=1, col_idx=c(3, 2, 4))@data,
    as.array(unfold(darr4, row_idx=1, col_idx=c(3, 2, 4))))
expect_equal(
    rTensor::unfold(tnsr4, row_idx=1, col_idx=c(3, 4, 2))@data,
    as.array(unfold(darr4, row_idx=1, col_idx=c(3, 4, 2))))
expect_equal(
    rTensor::unfold(tnsr4, row_idx=1, col_idx=c(4, 2, 3))@data,
    as.array(unfold(darr4, row_idx=1, col_idx=c(4, 2, 3))))
expect_equal(
    rTensor::unfold(tnsr4, row_idx=1, col_idx=c(4, 3, 2))@data,
    as.array(unfold(darr4, row_idx=1, col_idx=c(4, 3, 2))))

expect_equal(
    rTensor::unfold(tnsr4, row_idx=c(2, 4), col_idx=c(3, 1))@data,
    as.array(unfold(darr4, row_idx=c(2, 4), col_idx=c(3, 1))))

context("### modeSum ###")
print("modeSum")
expect_equal(
    rTensor::modeSum(tnsr4, m=1, drop=FALSE)@data,
    as.array(modeSum(darr4, m=1, drop=FALSE)))

expect_equal(
    rTensor::modeSum(tnsr4, m=2, drop=FALSE)@data,
    as.array(modeSum(darr4, m=2, drop=FALSE)))

expect_equal(
    rTensor::modeSum(tnsr4, m=3, drop=FALSE)@data,
    as.array(modeSum(darr4, m=3, drop=FALSE)))

expect_equal(
    rTensor::modeSum(tnsr4, m=4, drop=FALSE)@data,
    as.array(modeSum(darr4, m=4, drop=FALSE)))

expect_equal(
    rTensor::modeSum(tnsr4, m=1, drop=TRUE)@data,
    as.array(modeSum(darr4, m=1, drop=TRUE)))

expect_equal(
    rTensor::modeSum(tnsr4, m=2, drop=TRUE)@data,
    as.array(modeSum(darr4, m=2, drop=TRUE)))

expect_equal(
    rTensor::modeSum(tnsr4, m=3, drop=TRUE)@data,
    as.array(modeSum(darr4, m=3, drop=TRUE)))

expect_equal(
    rTensor::modeSum(tnsr4, m=4, drop=TRUE)@data,
    as.array(modeSum(darr4, m=4, drop=TRUE)))

context("### innerProd ###")
print("innerProd")
expect_equal(
    rTensor::innerProd(tnsr4, tnsr4),
    innerProd(darr4, darr4))

context("### vec ###")
print("vec")
expect_equal(
    rTensor::vec(tnsr4),
    as.vector(vec(darr4)))

context("### kronecker ###")
expect_equal(
    base::kronecker(arr4, arr4),
    as.array(kronecker(darr4, darr4)))

context("### fold ###")
print("fold")
matT4 <- rTensor::unfold(tnsr4, row_idx=1, col_idx=2:4)
dmatT4 <- unfold(darr4, row_idx=1, col_idx=2:4)
tnsr4_2 <- rTensor::fold(matT4,
    row_idx=1, col_idx=2:4, modes=c(2,3,4,5))
darr4_2 <- fold(dmatT4,
    row_idx=1, col_idx=2:4, modes=c(2,3,4,5))
expect_equal(
    arr4,
    tnsr4_2@data,
    as.array(darr4_2))

matT4 <- rTensor::unfold(tnsr4, row_idx=2, col_idx=c(3,1,4))
dmatT4 <- unfold(darr4, row_idx=2, col_idx=c(3,1,4))
tnsr4_3 <- rTensor::fold(matT4,
    row_idx=2, col_idx=c(3,1,4), modes=c(2,3,4,5))
darr4_3 <- fold(dmatT4,
    row_idx=2, col_idx=c(3,1,4), modes=c(2,3,4,5))
expect_equal(
    arr4,
    tnsr4_3@data,
    as.array(darr4_3))

matT4 <- rTensor::unfold(tnsr4, row_idx=3, col_idx=c(2,1,4))
dmatT4 <- unfold(darr4, row_idx=3, col_idx=c(2,1,4))
tnsr4_4 <- rTensor::fold(matT4,
    row_idx=3, col_idx=c(2,1,4), modes=c(2,3,4,5))
darr4_4 <- fold(dmatT4,
    row_idx=3, col_idx=c(2,1,4), modes=c(2,3,4,5))
expect_equal(
    arr4,
    tnsr4_4@data,
    as.array(darr4_4))

matT4 <- rTensor::unfold(tnsr4, row_idx=4, col_idx=c(3,2,1))
dmatT4 <- unfold(darr4, row_idx=4, col_idx=c(3,2,1))
tnsr4_5 <- rTensor::fold(matT4@data,
    row_idx=4, col_idx=c(3,2,1), modes=c(2,3,4,5))
darr4_5 <- fold(dmatT4,
    row_idx=4, col_idx=c(3,2,1), modes=c(2,3,4,5))
expect_equal(
    arr4,
    tnsr4_5@data,
    as.array(darr4_5))

context("### diag ###")
print("diag")
expect_equal(
    c(arr4[1,1,1,1], arr4[2,2,2,2]),
    as.vector(diag(darr4)))

context("### diag<- ###")
print("diag")
arr4_2 <- arr4
darr4_2 <- darr4
arr4_2[1,1,1,1] <- 111
arr4_2[2,2,2,2] <- 222
diag(darr4_2) <- c(111, 222)
expect_equal(
    c(arr4_2[1,1,1,1], arr4_2[2,2,2,2]),
    as.vector(diag(darr4_2)))

# Misc.R
context("### DelayedDiagonalArray ###")
print("DelayedDiagonalArray")
A <- DelayedDiagonalArray(c(3,4,5,6))
B <- DelayedDiagonalArray(c(3,4,5,6), 1:3)

expect_equal(A[1,1,1,1], 1)
expect_equal(A[2,2,2,2], 1)
expect_equal(A[3,3,3,3], 1)
expect_equal(A[3,4,5,6], 0)

expect_equal(B[1,1,1,1], 1)
expect_equal(B[2,2,2,2], 2)
expect_equal(B[3,3,3,3], 3)
expect_equal(B[3,4,5,6], 0)

library("DelayedArray")
# library("HDF5Array") # comment out
# library("BiocSingular") # comment out
library("rTensor")
library("DelayedRandomArray")
# library("irlba") # comment out
# library("Matrix") # comment out
library("einsum")
library("DelayedTensor")
library("reticulate")
library("testthat")
library("HDF5Array")

# Setting
options(testthat.use_colours = FALSE)
options(delayedtensor.sparse = FALSE)
options(delayedtensor.verbose = FALSE)
setHDF5DumpChunkLength(length = 1000000L)
setHDF5DumpCompressionLevel(level = 9L)
source("testthat/test_Einsum_objects.R")

# source("../R/Decomp.R") # comment out
# source("../R/Einsum.R") # comment out
# source("../R/Generics.R") # comment out
# source("../R/Global-settings.R") # comment out
# source("../R/Misc.R") # comment out
# source("../R/SVD.R") # comment out
# source("../R/Utils.R") # comment out
# source("../R/zzz.R") # comment out

# for(size in c(1E+9,1E+8,1E+7,1E+6,1E+5,1E+4,1E+3,1E+2,50,20:1)){ # comment out
# setAutoBlockSize(size=size) # comment out
# getAutoBlockSize() # comment out
test_file("testthat/test_Generics.R")
test_file("testthat/test_Misc.R")
# test_file("testthat/test_SVD.R") # comment out
test_file("testthat/test_4thorder.R")
test_file("testthat/test_Einsum.R")
# gc();gc() # comment out
# } # comment out

# setAutoBlockSize(size=1E+8)
# test_file("testthat/test_Decomp.R")
# test_file("testthat/test_Einsum_Py.R") # comment out
# source("testthat/test_Verbose.R")
# source("testthat/test_Sparse.R")

# Profiling
# source("testthat/test_SuperBig.R") # comment out

.svd <- function(dmat, k, ...){
    stopifnot("DelayedMatrix" %in% is(dmat))
    if(options()$delayedtensor.sparse){
        if(k >= min(dim(dmat))){
            stop("Please specify the smaller lower dimension k")
        }else{
            smat <- as(dmat, "sparseMatrix")
            out <- suppressWarnings(irlba(A=smat, nv=k))
        }
    }else{
        if(k >= 0.5 * min(dim(dmat))){
            out <- suppressWarnings(runExactSVD(dmat, k, ...))
        }else{
            out <- suppressWarnings(runIrlbaSVD(dmat, k, ...))
        }
    }
    out
}

# Setting
mat <- matrix(runif(5*6), nrow=5, ncol=6)
dmat <- DelayedArray(mat)

context("### svd ###\n")
for(k in seq(min(dim(dmat)))){
	out_m <- svd(mat, nu=k, nv=k)
	out_d <- .svd(dmat, k=k)
	expect_equal(
		dim(out_m$u),
		dim(out_d$u))
	expect_equal(
		dim(out_m$v),
		dim(out_d$v))
}

library("profvis")
library("einsum")
library("DelayedRandomArray")
library("DelayedArray")
library("DelayedTensor")

options(delayedtensor.verbose = TRUE)
setSparse(FALSE)
setAutoBlockSize(size=1E+7)
setHDF5DumpCompressionLevel(level=0L)
getAutoBlockSize()
getSparse()
getVerbose()

# data
darr_1E7 <- RandomNormArray(c(170,200,300))
darr_5E7 <- RandomNormArray(c(170,200,1500))
darr_1E8 <- RandomNormArray(c(400,500,500))
darr_5E8 <- RandomNormArray(c(400,500,2500))
darr_5E8_1 <- RandomNormArray(c(100,100))
darr_5E8_2 <- RandomNormArray(c(100,500))
darr_1E9_1 <- RandomNormArray(c(1000,100))
darr_1E9_2 <- RandomNormArray(c(100,100))

# unfold（1E8）
# .Callが遅いが、これが何をしているのか不明
profvis({
    out <- DelayedTensor::unfold(darr_1E8, row_idx=1, col_idx=c(2,3))
})

# fold（1E8）
# .Callが遅いが、これが何をしているのか不明
profvis({
    fold(out, row_idx=1, col_idx=c(2,3), modes=dim(darr_1E8))
})

# vec（1E8）
# .Callが遅いが、これが何をしているのか不明
profvis({
    DelayedTensor::vec(darr_1E8)
})

# innerProd（5E8）
# sum(darr*darr)を、あえて陽にBlock Processingで書いて早くなるかどうか...
profvis({
    DelayedTensor::innerProd(darr_5E8, darr_5E8)
})

# modeSum（5E7）
# 細かいピークがいっぱい出ているが...
profvis({
    DelayedTensor::modeSum(darr_5E7, m=1)
})

# kronecker（5E8）
# .Callが遅いが、これが何をしているのか不明
profvis({
    DelayedTensor::kronecker(darr_5E8_1, darr_5E8_2)
})

# einsum（5E8）
# .Callが遅いが、これが何をしているのか不明
profvis({
    DelayedTensor::einsum('ij,jk->ijk', darr_5E8_1, darr_5E8_2)
})
profvis({
    einsum::einsum('ij,jk->ijk', as.array(darr_5E8_1), as.array(darr_5E8_2))
})

.array <- function(dim){
    dim <- as.integer(dim)
    setAutoRealizationBackend("HDF5Array")
    sink <- AutoRealizationSink(dim)
    close(sink)
    as(sink, "DelayedArray")
}

# for fold, unfold, and modebind_list
.reshapeIncNumbers1D <- function(vecobj, new_modes){
    # Setting
    block.size <- getAutoBlockSize()
    dim(vecobj) <- c(dim(vecobj), 1) # Fake dimension
    num_modes <- length(new_modes)
    # Block Size Scheduling
    sink_spacings <- .blockSizeScheduling4(new_modes, num_modes, block.size)
    # e.g. 9×2=18 => [9×1], [9×1]
    sink_grid <- RegularArrayGrid(
        refdim=new_modes,
        spacings=sink_spacings)
    # Block Size Scheduling
    # e.g. 18 => [9], [9]
    tickmarks <- unlist(lapply(sink_grid, function(x){
        prod(dim(x))
    }))
    tickmarks <- list(as.integer(cumsum(tickmarks)), 1L)
    vec_grid <- ArbitraryArrayGrid(tickmarks = tickmarks)
    # Check
    .checkLimit(sink_grid, block.size)
    .checkLimit(vec_grid, block.size)
    stopifnot(identical(length(sink_grid), length(vec_grid)))
    # Block processing
    setAutoRealizationBackend("HDF5Array")
    sink <- AutoRealizationSink(new_modes)
    FUN <- function(sink_viewport, sink) {
        bid <- currentBlockId()
        block <- .block_reshape(vecobj, vec_grid, bid, sink_viewport)
        write_block(sink, sink_viewport, block)
    }
    sink <- gridReduce(FUN, sink_grid, sink,
        verbose=options()$delayedtensor.verbose)
    close(sink)
    as(sink, "DelayedArray")
}

.block_reshape <- function(vecobj, vec_grid, bid, sink_viewport){
    dim_sink_viewport <- as.integer(dim(sink_viewport))
    if(options()$delayedtensor.sparse){
        v <- read_block(vecobj, vec_grid[[bid]], as.sparse=TRUE)
        out <- COO_SparseArray(dim_sink_viewport)
        out@nzdata <- v@nzdata
        out@nzcoo <- Lindex2Mindex(v@nzcoo[,1], dim_sink_viewport)
        as.array(out)
    }else{
        v <- read_block(vecobj, vec_grid[[bid]], as.sparse=FALSE)
        dim(v) <- dim_sink_viewport
        v
    }
}

# Block Size Scheduling
.zeros <- function(n){
    rep(0, length=n)
}

# for hadamard, kronecker, khatri_rao
.blockSizeScheduling <- function(modes, block.size){
    num_modes <- length(modes)
    spacings <- .zeros(num_modes)
    for(i in seq_len(num_modes)){
        limit <- prod(modes[seq_len(i)])
        if(limit <= block.size){
            spacings[i] <- modes[i]
        }else{
            spacings[i] <- max(1, floor(block.size/(limit/modes[i])))
        }
    }
    spacings
}

# for kronecker, khatri_rao
.blockSizeScheduling2 <- function(modes1, modes2, block.size){
    num_modes <- length(modes1)
    spacings <- .zeros(num_modes)
    for(i in seq_len(num_modes)){
        limit <- prod(modes2) * prod(modes1[seq_len(i)])
        if(limit <= block.size){
            spacings[i] <- modes1[i]
        }else{
            spacings[i] <- max(1, floor(block.size/(limit/modes1[i])))
        }
    }
    spacings
}

# for .colSums
.blockSizeScheduling3 <- function(modes, block.size){
    num_modes <- length(modes)
    spacings <- .zeros(num_modes)
    for(i in seq_len(num_modes)){
        limit <- prod(modes[seq_len(i)])
        if(limit <= block.size){
            spacings[i] <- modes[i]
        }else{
            if(i == 1){
                idx <- 1
            }else{
                idx <- seq_len(i-1)
            }
            spacings[i] <- max(1,
                floor(block.size / prod(modes[idx])))
        }
    }
    spacings
}

# for .reshapeIncNumbers1D
.blockSizeScheduling4 <- function(new_modes, num_modes, block.size){
    spacings <- rep(0, length=num_modes)
    for(i in seq_len(num_modes)){
        limit <- prod(new_modes[seq_len(i)])
        if(limit <= block.size){
            spacings[i] <- new_modes[i]
        }else{
            if(i == 1){
                idx <- 1
            }else{
                idx <- seq_len(i-1)
            }
            # spacings[i] <- 1
            spacings[i] <- max(1, floor(block.size / prod(new_modes[idx])))
        }
    }
    spacings
}

# for .kronecker
.tickMarksScheduling1 <- function(new_modes, darr_grid_1, darr_grid_2){
    lapply(seq_along(new_modes), function(xx){
            dim_1 <- unlist(
                gridApply(darr_grid_1,
                    function(x){dim(x)[xx]}))[
                        seq_len(dim(darr_grid_1)[xx])]
            dim_2 <- unlist(
                gridApply(darr_grid_2,
                    function(x){dim(x)[xx]}))[
                        seq_len(dim(darr_grid_2)[xx])]
            out <- vapply(dim_1, function(x){
                dim_2 * x
            }, dim_2)
            out <- as.vector(out)
            out <- cumsum(out)
            as.integer(out)
        })
}

# for .khatri_rao
.tickMarksScheduling2 <- function(new_modes, darr_grid_1, darr_grid_2){
    # Row block size
    dim1_1 <- unlist(
        gridApply(darr_grid_1,
            function(x){dim(x)[1]}))[
                seq_len(dim(darr_grid_1)[1])]
    dim2_1 <- unlist(
        gridApply(darr_grid_2,
            function(x){dim(x)[1]}))[
                seq_len(dim(darr_grid_2)[1])]
    row_tickmark <- vapply(dim1_1, function(x){
        dim2_1 * x
    }, dim2_1)
    row_tickmark <- cumsum(row_tickmark)
    row_tickmark <- as.integer(row_tickmark)
    # Column block size
    col_index <- Mindex2Lindex(
        cbind(1, seq_len(dim(darr_grid_1)[2])), dim(darr_grid_1))
    col_tickmark <- vapply(col_index, function(x){
        dim(darr_grid_1[[x]])[2]
    }, 0L)
    col_tickmark <- cumsum(col_tickmark)
    col_tickmark <- as.integer(col_tickmark)
    # Output
    list(row_tickmark, col_tickmark)
}

.ndim <- function(x){
    length(dim(x))
}

.checkHOSVD <- function(ranks, darr){
    if(sum(ranks <= 0) != 0){
        stop("ranks must be positive")
    }
    if(.is_zero_tensor(darr)){
        stop("Zero tensor detected")
    }
}

.checkCP <- function(num_components, darr){
    if(is.null(num_components)){
        stop("num_components must be specified")
    }
    if(.is_zero_tensor(darr)){
        stop("Zero tensor detected")
    }
}

.checkTUCKER <- function(ranks, darr){
    if(is.null(ranks)){
        stop("ranks must be specified")
    }
    if(sum(ranks > dim(darr)) != 0){
        stop("ranks must be smaller than the corresponding mode")
    }
    if(sum(ranks <= 0) != 0){
        stop("ranks must be positive")
    }
    if(.is_zero_tensor(darr)){
        stop("Zero tensor detected")
    }
}

.checkMPCA <- function(ranks, darr){
    if(is.null(ranks)){
        stop("ranks must be specified")
    }
    if(sum(ranks > dim(darr)[seq(2)]) != 0){
        stop("ranks must be smaller than the corresponding mode")
    }
    if(sum(ranks <= 0) != 0){
        stop("ranks must be positive")
    }
    if(.is_zero_tensor(darr)){
        stop("Zero tensor detected")
    }
}

.checkPVD <- function(uranks, wranks, a, b, darr){
    modes <- dim(darr)
    if(.ndim(darr) != 3){
        stop("PVD only for 3D")
    }
    if (sum(uranks <= 0) != 0){
        stop("uranks must be positive")
    }
    if (sum(wranks <= 0) != 0){
        stop("wranks must be positive")
    }
    if (.is_zero_tensor(darr)){
        stop("Zero tensor detected")
    }
    if(is.null(uranks) || is.null(wranks)){
        stop("U and V ranks must be specified")
    }
    if(is.null(a) || is.null(b)){
        stop("a and b must be specified")
    }
    n <- modes[3]
    if(length(uranks) != n || length(wranks) != n){
        stop("ranks must be of length n3")
    }
}

.checkModeBindList <- function(L, m){
    stopifnot(is.list(L))
    lapply(L, .checkDelayedArray)
    .checkCommonDims(L, m)
    .checkNumModes(L)
    if(is.null(m)){
        stop("Specify m (e.g. m=2)")
    }
}

.checkModeSum <- function(darr, m){
    if(is.null(m)){
        stop("must specify mode m")
    }
    num_modes <- .ndim(darr)
    if(m<1 || m>num_modes){
        stop("m out of bounds")
    }
}

.checkHadamard <- function(darr1, darr2){
    mode1s <- as.integer(dim(darr1))
    mode2s <- as.integer(dim(darr2))
    if (!identical(mode1s, mode2s)){
        msg <- paste0("darr1 and darr2 must have the same number ",
            "of rows and columns.")
        stop(msg)
    }
}

.checkKronecker <- function(darr1, darr2){
    if(.ndim(darr1) != .ndim(darr2)){
        msg <- paste0("Please confirm that the two DelayedArray has",
            " the same number of modes, otherwise we cannot recognize",
            " which modes corespond each other")
        stop(msg)
    }
}

.checkKhatri_Rao <- function(darr1, darr2){
    .check2D(darr1)
    .check2D(darr2)
    mode1s <- as.integer(dim(darr1))
    mode2s <- as.integer(dim(darr2))
    if (mode1s[2] != mode2s[2]){
        stop("Arguments must have same number of columns.")
    }
}

.checkUnfold <- function(darr, row_idx, col_idx){
    if(is.null(row_idx) || is.null(col_idx)){
        stop("row and column indices must be specified")
    }
    num_modes <- .ndim(darr)
    if(any(row_idx < 1) || any(row_idx > num_modes) ||
        any(col_idx < 1) || any(col_idx > num_modes)){
        stop("illegal indices specified")
    }
    perm <- c(row_idx, col_idx)
    if(any(sort(perm, decreasing=TRUE) != rev(seq_len(num_modes)))){
        stop("missing and/or repeated indices")
    }
}

.checkFold <- function(mat, row_idx, col_idx, modes){
    if(is.null(row_idx) || is.null(col_idx)){
        stop("row space and col space indices must be specified")
    }
    if(is.null(modes)){
        stop("DelayedTensor modes must be specified")
    }
    num_modes <- length(modes)
    stopifnot(num_modes == length(row_idx)+length(col_idx))
    mat_modes <- dim(mat)
    check1 <- mat_modes[1] != prod(modes[row_idx])
    check2 <- mat_modes[2] != prod(modes[col_idx])
    if(check1 || check2){
        stop("matrix nrow/ncol does not match Tensor modes")
    }
}

.checkCommonDims <- function(L, m){
    dim_ms <- unlist(lapply(L, function(x,m){dim(x)[m]}, m=m))
    if(!all(dim_ms == dim_ms[1])){
        msg <- paste0("m must be specified as the common dimensions ",
            "among all the arrays in the list")
        stop(msg)
    }
}

.checkNumModes <- function(L){
    num_modes <- unlist(lapply(L, function(x){.ndim(x)}))
    if(!all(num_modes == num_modes[1])){
        msg <- paste0("all the arrays in the list must have the same number ",
            "of modes (length(dim(x)))")
        stop(msg)
    }
}

.checkLimit <- function(x, block.size){
    .checkArrayGrid(x)
    blocks <- unlist(gridApply(x, function(x){prod(dim(x))}))
    if(!all(blocks <= block.size)){
        stop("The block size is too large!!!")
    }
}

"%ni%" <- Negate("%in%")

.checkDelayedArray <- function(x){
    if("DelayedArray" %ni% is(x)){
        stop("Please specify the input as DelayedArray")
    }
}

.checkArrayGrid <- function(x){
    if("ArrayGrid" %ni% is(x)){
        stop("Please specify the input as ArrayGrid")
    }
}

.check2D <- function(x){
    if(.ndim(x) != 2){
        stop("Only 2D array (matrix) can be specified")
    }
}

.realize_and_return <- function(x){
    as(realize(x, "HDF5Array"), "DelayedArray")
}

#
# Tensor decomposition algorithms
#

# HOSVD (Tucker)
setGeneric("hosvd",
    function(darr, ranks=NULL){
        standardGeneric("hosvd")})
setMethod("hosvd", signature(darr="DelayedArray"),
    function(darr, ranks=NULL){
        .hosvd(darr, ranks)})
.hosvd <- function(darr, ranks){
    # Argument check
    .checkHOSVD(ranks, darr)
    # Setting
    num_modes <- .ndim(darr)
    #no truncation if ranks not provided
    if(is.null(ranks)){
        ranks <- dim(darr)
    }else{
        if (sum(ranks > dim(darr)) != 0){
            stop("ranks must be smaller than the corresponding mode")
        }
    }
    #progress bar
    pb <- txtProgressBar(min=0, max=num_modes, style=3)
    #loops through and performs SVD on mode-m matricization of darr
    U_list <- vector("list", num_modes)
    for(m in seq_len(num_modes)){
        temp_mat <- rs_unfold(darr, m=m)
        U_list[[m]] <- DelayedArray(.svd(temp_mat, k=ranks[m])$u)
        setTxtProgressBar(pb, m)
    }
    close(pb)
    #computes the core tensor
    Z <- ttl(darr, lapply(U_list, t), ms=seq_len(num_modes))
    est <- ttl(Z, U_list, ms=seq_len(num_modes))
    resid <- fnorm(est - darr)
    #put together the return list, and returns
    list(Z=Z, U=U_list, est=est, fnorm_resid=resid)
}

# CP
setGeneric("cp",
    function(darr, num_components=NULL, max_iter=25, tol=1e-5){
        standardGeneric("cp")})
setMethod("cp", signature(darr="DelayedArray"),
    function(darr, num_components=NULL, max_iter=25, tol=1e-5){
        .cp(darr, num_components, max_iter, tol)})
.cp <- function(darr, num_components, max_iter, tol){
    # Argument check
    .checkCP(num_components, darr)
    # Setting
    num_modes <- .ndim(darr)
    modes <- dim(darr)
    U_list <- unfolded_mat <- vector("list", num_modes)
    darr_norm <- fnorm(darr)
    for(m in seq_len(num_modes)){
        unfolded_mat[[m]] <- rs_unfold(darr, m=m)
        U_list[[m]] <- RandomNormArray(dim=c(modes[m], num_components))
    }
    est <- darr
    curr_iter <- 1
    converged <- FALSE
    fnorm_resid <- rep(0, max_iter)
    pb <- txtProgressBar(min=0, max=max_iter, style=3)
    while((curr_iter < max_iter) && (!converged)){
        setTxtProgressBar(pb, curr_iter)
        for(m in seq_len(num_modes)){
            V_inv <- solve(hadamard_list(lapply(U_list[-m], function(x){
                    t(x) %*% x})))
            tmp <- as(khatri_rao_list(U_list[-m],reverse=TRUE), "DelayedMatrix")
            tmp2 <- unfolded_mat[[m]] %*% tmp %*% V_inv
            lambdas <- colSums(abs(tmp2))
            U_list[[m]] <- sweep(tmp2, 2, lambdas, "/")
            Z <- DelayedDiagonalArray(
                rep(num_components, length=num_modes), lambdas)
            est <- ttl(Z, U_list, ms=seq_len(num_modes))
        }
        conv_cp <- .CHECK_CONV_CP(est, darr, curr_iter, fnorm_resid,
            darr_norm, tol)
        fnorm_resid <- conv_cp$fnorm_resid
        conv <- conv_cp$conv
        if(conv){
            converged <- TRUE
            setTxtProgressBar(pb, max_iter)
        }else{
            curr_iter <- curr_iter + 1
        }
    }
    if(!converged){setTxtProgressBar(pb, max_iter)}
    close(pb)
    fnorm_resid <- fnorm_resid[fnorm_resid != 0]
    norm_percent <- (1 - (tail(fnorm_resid, 1) / darr_norm)) * 100
    list(lambdas=lambdas, U=U_list, conv=converged, est=est,
        norm_percent=norm_percent, fnorm_resid = tail(fnorm_resid,1),
        all_resids=fnorm_resid)
}

.CHECK_CONV_CP <- function(est, darr, curr_iter, fnorm_resid, darr_norm, tol){
    curr_resid <- fnorm(est - darr)
    fnorm_resid[curr_iter] <- curr_resid
    if (curr_iter == 1){
        return(list(fnorm_resid=fnorm_resid, conv=FALSE))
    }else{
        if(abs(curr_resid-fnorm_resid[curr_iter-1])/darr_norm < tol){
            return(list(fnorm_resid=fnorm_resid, conv=TRUE))
        }
        else{
            return(list(fnorm_resid=fnorm_resid, conv=FALSE))
        }
    }
}

# HOOI (Tucker)
setGeneric("tucker",
    function(darr, ranks=NULL, max_iter=25, tol=1e-5){
        standardGeneric("tucker")})
setMethod("tucker", signature(darr="DelayedArray"),
    function(darr, ranks=NULL, max_iter=25, tol=1e-5){
        .tucker(darr, ranks, max_iter, tol)})
.tucker <- function(darr, ranks, max_iter, tol){
    # Argument check
    .checkTUCKER(ranks, darr)
    # Setting
    num_modes <- .ndim(darr)
    U_list <- vector("list", num_modes)
    for(m in seq_len(num_modes)){
        temp_mat <- rs_unfold(darr, m=m)
        U_list[[m]] <- DelayedArray(.svd(temp_mat, k=ranks[m])$u)
    }
    darr_norm <- fnorm(darr)
    curr_iter <- 1
    converged <- FALSE
    #set up convergence check
    fnorm_resid <- rep(0, max_iter)
    pb <- txtProgressBar(min=0, max=max_iter, style=3)
    #main loop (until convergence or max_iter)
    while((curr_iter < max_iter) && (!converged)){
        setTxtProgressBar(pb, curr_iter)
        modes <- .ndim(darr)
        modes_seq <- seq_len(num_modes)
        for(m in modes_seq){
            X <- ttl(darr, lapply(U_list[-m], t), ms=modes_seq[-m])
            U_list[[m]] <-
                DelayedArray(.svd(rs_unfold(X, m=m), k=ranks[m])$u)
        }
        #compute core tensor Z
        Z <- ttm(X, mat=t(U_list[[num_modes]]), m=num_modes)
        #checks convergence
        conv_tucker <- .CHECK_CONV_Tucker(Z, U_list, num_modes, est, darr,
            curr_iter, fnorm_resid, darr_norm, tol)
        fnorm_resid <- conv_tucker$fnorm_resid
        conv <- conv_tucker$conv
        if(conv){
            converged <- TRUE
            setTxtProgressBar(pb, max_iter)
        }else{
            curr_iter <- curr_iter + 1
        }
    }
    close(pb)
    fnorm_resid <- fnorm_resid[fnorm_resid != 0]
    norm_percent <- (1 - (tail(fnorm_resid, 1) / darr_norm)) * 100
    est <- ttl(Z, U_list, ms=seq_len(num_modes))
    list(Z=Z, U=U_list, conv=converged, est=est, norm_percent = norm_percent,
        fnorm_resid=tail(fnorm_resid, 1), all_resids=fnorm_resid)
}

.CHECK_CONV_Tucker <- function(Z, U_list, num_modes, est, darr,
    curr_iter, fnorm_resid, darr_norm, tol){
    est <- ttl(Z, U_list, ms=seq_len(num_modes))
    curr_resid <- fnorm(darr - est)
    fnorm_resid[curr_iter] <- curr_resid
    if(curr_iter == 1){
        return(list(fnorm_resid=fnorm_resid, conv=FALSE))
    }
    if(abs(curr_resid - fnorm_resid[curr_iter-1])/darr_norm < tol){
        return(list(fnorm_resid=fnorm_resid, conv=TRUE))
    }else{
        return(list(fnorm_resid=fnorm_resid, conv=FALSE))
    }
}

# MPCA
setGeneric("mpca",
    function(darr, ranks=NULL, max_iter=25, tol=1e-5){
        standardGeneric("mpca")})
setMethod("mpca", signature(darr="DelayedArray"),
    function(darr, ranks=NULL, max_iter=25, tol=1e-5){
        .mpca(darr, ranks, max_iter, tol)})
.mpca <- function(darr, ranks, max_iter, tol){
    # Argument check
    .checkMPCA(ranks, darr)
    # Setting
    num_modes <- .ndim(darr)
    stopifnot(length(ranks) == (num_modes - 1))
    ranks <- c(ranks, 1)
    modes <- dim(darr)
    U_list <- vector("list", num_modes)
    unfolded_mat <- vector("list", num_modes)
    for(m in seq_len(num_modes-1)){
        unfolded_mat <- rs_unfold(darr, m=m)
        mode_m_cov <- unfolded_mat %*% t(unfolded_mat)
        U_list[[m]] <- DelayedArray(.svd(mode_m_cov, k=ranks[m])$u)
    }
    Z_ext <- ttl(darr, lapply(U_list[-num_modes], t), ms=seq_len(num_modes-1))
    darr_norm <- fnorm(darr)
    curr_iter <- 1
    converged <- FALSE
    fnorm_resid <- rep(0, max_iter)
    pb <- txtProgressBar(min=0, max=max_iter, style=3)
    while((curr_iter < max_iter) && (!converged)){
        setTxtProgressBar(pb, curr_iter)
        modes <-dim(darr)
        modes_seq <- seq_len(num_modes-1)
        for(m in modes_seq){
            X <- ttl(darr, lapply(U_list[-c(m,num_modes)], t), ms=modes_seq[-m])
            U_list[[m]] <- DelayedArray(.svd(rs_unfold(X,m=m), k=ranks[m])$u)
        }
        Z_ext <- ttm(X, mat=t(U_list[[num_modes-1]]), m=num_modes-1)
        conv_mpca <- .CHECK_CONV_MPCA(Z_ext, U_list, num_modes, est, darr,
            curr_iter, fnorm_resid, darr_norm, tol)
        fnorm_resid <- conv_mpca$fnorm_resid
        conv <- conv_mpca$conv
        if(conv){
            converged <- TRUE
            setTxtProgressBar(pb, max_iter)
        }else{
            curr_iter <- curr_iter + 1
        }
    }
    close(pb)
    est <- ttl(Z_ext, U_list[-num_modes], ms=seq_len(num_modes-1))
    fnorm_resid <- fnorm_resid[fnorm_resid!=0]
    norm_percent <-(1 - (tail(fnorm_resid, 1) / darr_norm)) * 100
    list(Z_ext=Z_ext, U=U_list, conv=converged, est=est,
        norm_percent = norm_percent, fnorm_resid=tail(fnorm_resid,1),
        all_resids=fnorm_resid)
}

.CHECK_CONV_MPCA <- function(Z_ext, U_list, num_modes, est, darr, curr_iter,
fnorm_resid, darr_norm, tol){
    est <- ttl(Z_ext, U_list[-num_modes], ms=seq_len(num_modes-1))
    curr_resid <- fnorm(darr - est)
    fnorm_resid[curr_iter] <- curr_resid
    if(curr_iter == 1){
        return(list(fnorm_resid=fnorm_resid, conv=FALSE))
    }
    if(abs(curr_resid-fnorm_resid[curr_iter-1])/darr_norm < tol){
        return(list(fnorm_resid=fnorm_resid, conv=TRUE))
    }else{
        return(list(fnorm_resid=fnorm_resid, conv=FALSE))
    }
}

# PVD
setGeneric("pvd",
    function(darr, uranks=NULL, wranks=NULL, a=NULL, b=NULL){
        standardGeneric("pvd")})
setMethod("pvd", signature(darr="DelayedArray"),
    function(darr, uranks=NULL, wranks=NULL, a=NULL, b=NULL){
        .pvd(darr, uranks, wranks, a, b)})
.pvd <- function(darr, uranks, wranks, a, b){
    # Argument check
    .checkPVD(uranks, wranks, a, b, darr)
    # Setting
    uranks <- as.integer(uranks)
    wranks <- as.integer(wranks)
    a <- as.integer(a)
    b <- as.integer(b)
    modes <- dim(darr)
    n <- modes[3]
    pb <- txtProgressBar(min=0, max=(n+3), style=3)
    Us <- vector('list', n)
    Vs <- vector('list', n)
    S <- vector('list', n)
    for(i in seq_len(n)){
        svdz <- .svd(darr[,,i], k=max(uranks[i], wranks[i]))
        Us[[i]] <- DelayedArray(svdz$u[, seq_len(uranks[i])])
        Vs[[i]] <- DelayedArray(svdz$v[, seq_len(wranks[i])])
        S[[i]] <- svdz$d[seq_len(min(uranks[i], wranks[i]))]
        setTxtProgressBar(pb, i)
    }
    U <- cbind_list(Us)
    U <- as(cbind_list(list_rep(U, sum(uranks)*n/ncol(U))), "DelayedMatrix")
    UtU <- as(U %*% t(U), "DelayedMatrix")
    P <- DelayedArray(.svd(UtU, k=a)$u)
    setTxtProgressBar(pb, n+1)
    V <- cbind_list(Vs)
    V <- as(cbind_list(list_rep(V, sum(wranks)*n/ncol(V))), "DelayedMatrix")
    Dt <- DelayedArray(.svd(V %*% t(V), k=b)$u)
    D <- t(Dt)
    setTxtProgressBar(pb, n+2)
    V2 <- vector('list', n)
    est <- array(0, dim=modes)
    for(i in seq_len(n)){
        diagS <- DelayedDiagonalArray(c(uranks[i], wranks[i]), S[[i]])
        diagS <- as(diagS, "DelayedMatrix")
        V2[[i]] <- .realize_and_return((t(P) %*% Us[[i]]) %*% diagS %*%
            (t(Vs[[i]]) %*% Dt))
        V2[[i]] <- as(V2[[i]], "DelayedMatrix")
        est[,,i] <- as.array(P %*% V2[[i]] %*% D)
    }
    est <- DelayedArray(est)
    fnorm_resid <- fnorm(est - darr)
    setTxtProgressBar(pb, n+3)
    norm_percent <- (1 - (fnorm_resid / fnorm(darr))) * 100
    list(P=P, D=D, V=V2, est=est,
        norm_percent=norm_percent, fnorm_resid=fnorm_resid)
}

.is_zero_tensor <- function(darr){
    size <- prod(dim(darr))
    if(size >= 10^3){
        nzero <- sum(darr[seq_len(10^3)] == 0)
    }else{
        nzero <- sum(darr == 0)
    }
    if(all(nzero) == size){
        TRUE
    }
    FALSE
}

# Ref
# https://github.com/rikenbit/rTensor/blob/master/R/rTensor_Decomp.R

#
# Utility function to merge multiple Tensor based on
# Einstein's summation convention
#
# subscripts = 'ij->ji'
# operands = list(darrD)
einsum <- function(subscripts, ...){
    # Preprocessing
    subscripts <- gsub(" ", "", subscripts)
    operands <- list(...)
    # Argument Check & Setting
    em <- .checkEinsum(subscripts, operands)
    all_modes <- em$all_modes
    modes <- em$modes
    new_modes <- em$new_modes
    check_perm <- em$check_perm
    block.size <- getAutoBlockSize()
    if(check_perm){
        .sortOperands(operands, new_modes, modes)
    }else{
        # Spacing
        all_spacings <- .blockSizeSchedulingList(all_modes, modes, block.size)
        ## operands & operands_grids
        operands_spacings <- .operands_spacings(modes, all_spacings)
        operands_grids <- .RegularArrayGridList(modes, operands_spacings)
        ## index
        idx_grids <- RegularArrayGrid(all_modes, all_spacings)
        ## sink
        sink_grid <- .RegularArrayGrid(new_modes, all_spacings)
        ## check
        lapply(operands_grids, function(x, bs){
            .checkLimit(x, bs)}, bs=block.size)
        .checkLimit(idx_grids, block.size)
        .checkLimit(sink_grid, block.size)
        # Block processing
        setAutoRealizationBackend("HDF5Array")
        sink <- AutoRealizationSink(as.vector(new_modes))
        for(bid in seq_along(idx_grids)){
            idx <- Lindex2Mindex(bid, dim(idx_grids))
            colnames(idx) <- names(dim(idx_grids))
            block1 <- .read_block_einsum(new_modes, idx, sink_grid, sink)
            block2 <- .block_einsum(subscripts, operands, operands_grids,
                modes, idx)
            sink <- .write_block_einsum(new_modes, idx, sink_grid,
                sink, block1, block2)
            if(options()$delayedtensor.verbose){
                cat(paste0("\\ Processing viewport ",
                    bid, "/", length(idx_grids), " ... OK\n"))
            }
        }
        close(sink)
        as(sink, "DelayedArray")
    }
}

# for Block processing
.block_einsum <- function(subscripts, operands, operands_grids, modes, idx){
    cmd1 <- lapply(seq_along(operands), function(x){
        paste0("idx", letters[x], " <- Mindex2Lindex(",
        "idx[, names(modes[[", x, "]])]",
        ", dim(operands_grids[[", x, "]]))")
    })
    cmd2 <- lapply(seq_along(operands), function(x){
        paste0(letters[x], " <- read_block(operands[[", x, "L]]",
            ", operands_grids[[", x, "L]][[idx", letters[x], "]])")
    })
    cmd3 <- paste0("einsum::einsum(subscripts, ",
        paste(letters[seq_along(operands)], collapse=", "), ")")
    eval(parse(text=cmd1))
    eval(parse(text=cmd2))
    eval(parse(text=cmd3))
}

# for sink
.tickMarksScheduling3 <- function(new_modes, all_spacings){
    if(identical(new_modes, 1L)){
        list(new_modes)
    }else{
        lapply(seq_along(new_modes), function(x){
            out <- as.vector(seq(1, new_modes[x], by=all_spacings[x]))
            if(identical(out, 1)){
                as.integer(new_modes[x])
            }else{
                as.integer(out)
            }
        })
    }
}

# for sink
.RegularArrayGrid <- function(new_modes, all_spacings){
    if(identical(new_modes, 1L)){
        RegularArrayGrid(1L, 1L)
    }else{
        RegularArrayGrid(as.vector(new_modes),
                all_spacings[names(new_modes)])
    }
}

# for sink
.read_block_einsum <- function(new_modes, idx, sink_grid, sink){
    if(identical(new_modes, 1L)){
        sink_idx <- 1L
    }else{
        midx <- idx[, names(new_modes)]
        sink_idx <- Mindex2Lindex(midx, dim(sink_grid))
    }
    read_block(as(sink, "DelayedArray"), sink_grid[[sink_idx]])
}

# for sink
.write_block_einsum <- function(new_modes, idx, sink_grid,
    sink, block1, block2){
    if(identical(new_modes, 1L)){
        sink_idx <- 1L
    }else{
        midx <- idx[, names(new_modes)]
        sink_idx <- Mindex2Lindex(midx, dim(sink_grid))
    }
    write_block(sink, sink_grid[[sink_idx]], block1 + block2)
}

# Return List
.blockSizeSchedulingList <- function(all_modes, modes, block.size){
    num_modes <- length(all_modes)
    all_spacings <- all_modes
    all_spacings[] <- 0
    for(i in seq_len(num_modes)){
        limit1 <- prod(all_modes[seq_len(i)])
        limit2 <- max(unlist(lapply(modes, function(x){
                    target <- unlist(lapply(
                        names(all_modes[seq_len(i)]),
                            function(xx){which(xx == names(x))}))
                                prod(x[target])})))
        limit <- max(limit1, limit2)
        if(limit <= block.size){
            all_spacings[i] <- all_modes[i]
        }else{
            all_spacings[i] <- max(1, floor(block.size/(limit/all_modes[i])))
        }
    }
    all_spacings
}

.operands_spacings <- function(modes, all_spacings){
    lapply(modes, function(m){as.vector(all_spacings[names(m)])})
}

.idx_spacings <- function(all_modes, all_spacings){
    out <- lapply(names(all_modes), function(m){
        as.vector(all_spacings[m])
    })
    names(out) <- names(all_modes)
    out
}

# Return List
.RegularArrayGridList <- function(modes, operands_spacings){
    lapply(seq_along(modes), function(x){
        RegularArrayGrid(refdim=as.vector(modes[[x]]),
            spacings=operands_spacings[[x]])
    })
}

# Argument Check & Setting
.checkEinsum <- function(subscripts, operands){
    no_operands <- length(operands)
    no_comma <- .no_comma(subscripts)
    if(no_comma == -1){
        no_comma <- 0
    }
    lapply(operands, .checkDelayedArray)
    if(no_operands-1 != no_comma){
        msg <- paste0("(No. of operands - 1) and (No. of ,) are ",
            no_operands-1, " and ", no_comma, " and different!")
        stop(msg)
    }
    if(length(grep("->", subscripts)) != 1){
        if(length(grep("->", subscripts)) == 0){
            msg <- paste0("Please make sure that equation_string ",
                "has explicit indicator (->)")
        }
        if(length(grep("->", subscripts)) > 1){
            msg <- paste0("Please make sure that equation_string ",
                "has single explicit indicator (->)")
        }
        stop(msg)
    }
    lfs <- .left_sub(subscripts)
    split_subscripts <- strsplit(lfs, ",")[[1]]
    rhs <- .right_sub(subscripts)
    check_perm <- .check_perm(lfs, rhs)
    # all_modes
    all_modes <- .s_to_d(subscripts, operands)
    # modes (operands)
    names_modes <- lapply(seq_along(split_subscripts), function(x){
        strsplit(split_subscripts[x], "")[[1]]
    })
    modes <- lapply(seq_along(operands), function(x){
        tmp <- dim(operands[[x]])
        names(tmp) <- names_modes[[x]]
        tmp
    })
    names(modes) <- paste0("darr", seq_along(split_subscripts))
    # new_modes (for sink)
    if(is.na(rhs)){
        new_modes <- 1L
    }else{
        new_modes <- all_modes[strsplit(rhs, "")[[1]]]
    }
    # Output
    list(all_modes=all_modes, modes=modes, new_modes=new_modes,
        check_perm=check_perm)
}

# Sort (e.g. ji)
.sortOperands <- function(operands, new_modes, modes){
    orderO <- unlist(lapply(names(new_modes), function(x){
        which(x == names(modes[[1]]))
    }))
    .realize_and_return(aperm(operands[[1]], orderO))
}

# whether left and right are same
.check_perm <- function(lfs, rhs){
    left <- strsplit(lfs, "")[[1]]
    right <- strsplit(rhs, "")[[1]]
    identical(sort(left), sort(right))
}

# No. of comma
.no_comma <- function(subscripts){
    tmp = strsplit(subscripts, "")[[1]]
    length(grep(",", tmp))
}

# subscripts -> dims
.s_to_d <- function(subscripts, operands){
    odims <- unlist(lapply(operands, function(o){dim(o)}))
    sbs <- strsplit(gsub(",", "", .left_sub(subscripts)), "")[[1]]
    common.sbs <- sort(unique(sbs))
    out <- unlist(lapply(common.sbs, function(c){
        odims[which(sbs == c)[1]]
    }))
    names(out) <- common.sbs
    out
}

# left subscripts
.left_sub <- function(subscripts){
    strsplit(subscripts, "->")[[1]][1]
}

# right subscripts
.right_sub <- function(subscripts){
    strsplit(subscripts, "->")[[1]][2]
}

# DelayedArray arrects

context("### einsum (transpose) ###\n")
expect_equal(t(arrD),
    einsum::einsum('ij->ji', arrD),
    as.array(einsum('ij->ji', darrD)))

expect_equal(aperm(arrF, c(1,3,2)),
    einsum::einsum('ijk->ikj', arrF),
    as.array(einsum('ijk->ikj', darrF)))
expect_equal(aperm(arrF, c(2,1,3)),
    einsum::einsum('ijk->jik', arrF),
    as.array(einsum('ijk->jik', darrF)))
expect_equal(aperm(arrF, c(2,3,1)),
    einsum::einsum('ijk->jki', arrF),
    as.array(einsum('ijk->jki', darrF)))
expect_equal(aperm(arrF, c(3,1,2)),
    einsum::einsum('ijk->kij', arrF),
    as.array(einsum('ijk->kij', darrF)))
expect_equal(aperm(arrF, c(3,2,1)),
    einsum::einsum('ijk->kji', arrF),
    as.array(einsum('ijk->kji', darrF)))
expect_equal(aperm(arrG, c(1,2,4,3)),
    einsum::einsum('ijkl->ijlk', arrG),
    as.array(einsum('ijkl->ijlk', darrG)))
expect_equal(aperm(arrG, c(1,3,2,4)),
    einsum::einsum('ijkl->ikjl', arrG),
    as.array(einsum('ijkl->ikjl', darrG)))
expect_equal(aperm(arrG, c(1,3,4,2)),
    einsum::einsum('ijkl->iklj', arrG),
    as.array(einsum('ijkl->iklj', darrG)))
expect_equal(aperm(arrG, c(1,4,2,3)),
    einsum::einsum('ijkl->iljk', arrG),
    as.array(einsum('ijkl->iljk', darrG)))
expect_equal(aperm(arrG, c(1,4,3,2)),
    einsum::einsum('ijkl->ilkj', arrG),
    as.array(einsum('ijkl->ilkj', darrG)))
expect_equal(aperm(arrG, c(2,1,3,4)),
    einsum::einsum('ijkl->jikl', arrG),
    as.array(einsum('ijkl->jikl', darrG)))
expect_equal(aperm(arrG, c(2,1,4,3)),
    einsum::einsum('ijkl->jilk', arrG),
    as.array(einsum('ijkl->jilk', darrG)))
expect_equal(aperm(arrG, c(2,3,1,4)),
    einsum::einsum('ijkl->jkil', arrG),
    as.array(einsum('ijkl->jkil', darrG)))
expect_equal(aperm(arrG, c(2,3,4,1)),
    einsum::einsum('ijkl->jkli', arrG),
    as.array(einsum('ijkl->jkli', darrG)))
expect_equal(aperm(arrG, c(2,4,1,3)),
    einsum::einsum('ijkl->jlik', arrG),
    as.array(einsum('ijkl->jlik', darrG)))
expect_equal(aperm(arrG, c(2,4,3,1)),
    einsum::einsum('ijkl->jlki', arrG),
    as.array(einsum('ijkl->jlki', darrG)))
expect_equal(aperm(arrG, c(3,1,2,4)),
    einsum::einsum('ijkl->kijl', arrG),
    as.array(einsum('ijkl->kijl', darrG)))
expect_equal(aperm(arrG, c(3,1,4,2)),
    einsum::einsum('ijkl->kilj', arrG),
    as.array(einsum('ijkl->kilj', darrG)))
expect_equal(aperm(arrG, c(3,2,1,4)),
    einsum::einsum('ijkl->kjil', arrG),
    as.array(einsum('ijkl->kjil', darrG)))
expect_equal(aperm(arrG, c(3,2,4,1)),
    einsum::einsum('ijkl->kjli', arrG),
    as.array(einsum('ijkl->kjli', darrG)))
expect_equal(aperm(arrG, c(3,4,1,2)),
    einsum::einsum('ijkl->klij', arrG),
    as.array(einsum('ijkl->klij', darrG)))
expect_equal(aperm(arrG, c(3,4,2,1)),
    einsum::einsum('ijkl->klji', arrG),
    as.array(einsum('ijkl->klji', darrG)))
expect_equal(aperm(arrG, c(4,1,2,3)),
    einsum::einsum('ijkl->lijk', arrG),
    as.array(einsum('ijkl->lijk', darrG)))
expect_equal(aperm(arrG, c(4,1,3,2)),
    einsum::einsum('ijkl->likj', arrG),
    as.array(einsum('ijkl->likj', darrG)))
expect_equal(aperm(arrG, c(4,2,1,3)),
    einsum::einsum('ijkl->ljik', arrG),
    as.array(einsum('ijkl->ljik', darrG)))
expect_equal(aperm(arrG, c(4,2,3,1)),
    einsum::einsum('ijkl->ljki', arrG),
    as.array(einsum('ijkl->ljki', darrG)))
expect_equal(aperm(arrG, c(4,3,1,2)),
    einsum::einsum('ijkl->lkij', arrG),
    as.array(einsum('ijkl->lkij', darrG)))
expect_equal(aperm(arrG, c(4,3,2,1)),
    einsum::einsum('ijkl->lkji', arrG),
    as.array(einsum('ijkl->lkji', darrG)))

context("### einsum (sum + permutation) ###\n")
expect_equal(sum(arrA),
    as.vector(einsum::einsum('i->', arrA)),
    as.vector(einsum('i->', darrA)))
expect_equal(sum(arrD),
    as.vector(einsum::einsum('ij->', arrD)),
    as.vector(einsum('ij->', darrD)))

expect_equal(rowSums(arrD),
    as.vector(einsum::einsum('ij->i', arrD)),
    as.vector(einsum('ij->i', darrD)))
expect_equal(colSums(arrD),
    as.vector(einsum::einsum('ij->j', arrD)),
    as.vector(einsum('ij->j', darrD)))

expect_equal(sum(arrF),
    as.vector(einsum::einsum('ijk->', arrF)),
    as.vector(einsum('ijk->', darrF)))
expect_equal(tmp1,
    as.vector(einsum::einsum('ijk->i', arrF)),
    as.vector(einsum('ijk->i', darrF)))
expect_equal(tmp2,
    as.vector(einsum::einsum('ijk->j', arrF)),
    as.vector(einsum('ijk->j', darrF)))
expect_equal(tmp3,
    as.vector(einsum::einsum('ijk->k', arrF)),
    as.vector(einsum('ijk->k', darrF)))
expect_equal(tmp4,
    as.array(einsum::einsum('ijk->ij', arrF)),
    as.array(einsum('ijk->ij', darrF)))
expect_equal(tmp5,
    as.array(einsum::einsum('ijk->jk', arrF)),
    as.array(einsum('ijk->jk', darrF)))
expect_equal(tmp6,
    as.array(einsum::einsum('ijk->ik', arrF)),
    as.array(einsum('ijk->ik', darrF)))
expect_equal(sum(arrG),
    as.vector(einsum::einsum('ijkl->', arrG)),
    as.vector(einsum('ijkl->', darrG)))
expect_equal(tmp7,
    as.vector(einsum::einsum('ijkl->i', arrG)),
    as.vector(einsum('ijkl->i', darrG)))
expect_equal(tmp8,
    as.vector(einsum::einsum('ijkl->j', arrG)),
    as.vector(einsum('ijkl->j', darrG)))
expect_equal(tmp9,
    as.vector(einsum::einsum('ijkl->k', arrG)),
    as.vector(einsum('ijkl->k', darrG)))
expect_equal(tmp10,
    as.vector(einsum::einsum('ijkl->l', arrG)),
    as.vector(einsum('ijkl->l', darrG)))
expect_equal(tmp11,
    as.array(einsum::einsum('ijkl->ij', arrG)),
    as.array(einsum('ijkl->ij', darrG)))
expect_equal(tmp12,
    as.array(einsum::einsum('ijkl->ik', arrG)),
    as.array(einsum('ijkl->ik', darrG)))
expect_equal(tmp13,
    as.array(einsum::einsum('ijkl->il', arrG)),
    as.array(einsum('ijkl->il', darrG)))
expect_equal(tmp14,
    as.array(einsum::einsum('ijkl->ji', arrG)),
    as.array(einsum('ijkl->ji', darrG)))
expect_equal(tmp15,
    as.array(einsum::einsum('ijkl->jk', arrG)),
    as.array(einsum('ijkl->jk', darrG)))
expect_equal(tmp16,
    as.array(einsum::einsum('ijkl->jl', arrG)),
    as.array(einsum('ijkl->jl', darrG)))
expect_equal(tmp17,
    as.array(einsum::einsum('ijkl->ki', arrG)),
    as.array(einsum('ijkl->ki', darrG)))
expect_equal(tmp18,
    as.array(einsum::einsum('ijkl->kj', arrG)),
    as.array(einsum('ijkl->kj', darrG)))
expect_equal(tmp19,
    as.array(einsum::einsum('ijkl->kl', arrG)),
    as.array(einsum('ijkl->kl', darrG)))
expect_equal(tmp20,
    as.array(einsum::einsum('ijkl->li', arrG)),
    as.array(einsum('ijkl->li', darrG)))
expect_equal(tmp21,
    as.array(einsum::einsum('ijkl->lj', arrG)),
    as.array(einsum('ijkl->lj', darrG)))
expect_equal(tmp22,
    as.array(einsum::einsum('ijkl->lk', arrG)),
    as.array(einsum('ijkl->lk', darrG)))
expect_equal(tmp23,
    as.array(einsum::einsum('ijkl->ijk', arrG)),
    as.array(einsum('ijkl->ijk', darrG)))
expect_equal(tmp24,
    as.array(einsum::einsum('ijkl->ijl', arrG)),
    as.array(einsum('ijkl->ijl', darrG)))
expect_equal(tmp25,
    as.array(einsum::einsum('ijkl->ikj', arrG)),
    as.array(einsum('ijkl->ikj', darrG)))
expect_equal(tmp26,
    as.array(einsum::einsum('ijkl->ikl', arrG)),
    as.array(einsum('ijkl->ikl', darrG)))
expect_equal(tmp27,
    as.array(einsum::einsum('ijkl->ilj', arrG)),
    as.array(einsum('ijkl->ilj', darrG)))
expect_equal(tmp28,
    as.array(einsum::einsum('ijkl->ilk', arrG)),
    as.array(einsum('ijkl->ilk', darrG)))
expect_equal(tmp29,
    as.array(einsum::einsum('ijkl->jik', arrG)),
    as.array(einsum('ijkl->jik', darrG)))
expect_equal(tmp30,
    as.array(einsum::einsum('ijkl->jil', arrG)),
    as.array(einsum('ijkl->jil', darrG)))
expect_equal(tmp31,
    as.array(einsum::einsum('ijkl->jki', arrG)),
    as.array(einsum('ijkl->jki', darrG)))
expect_equal(tmp32,
    as.array(einsum::einsum('ijkl->jkl', arrG)),
    as.array(einsum('ijkl->jkl', darrG)))
expect_equal(tmp33,
    as.array(einsum::einsum('ijkl->jli', arrG)),
    as.array(einsum('ijkl->jli', darrG)))
expect_equal(tmp34,
    as.array(einsum::einsum('ijkl->jlk', arrG)),
    as.array(einsum('ijkl->jlk', darrG)))
expect_equal(tmp35,
    as.array(einsum::einsum('ijkl->kij', arrG)),
    as.array(einsum('ijkl->kij', darrG)))
expect_equal(tmp36,
    as.array(einsum::einsum('ijkl->kil', arrG)),
    as.array(einsum('ijkl->kil', darrG)))
expect_equal(tmp37,
    as.array(einsum::einsum('ijkl->kji', arrG)),
    as.array(einsum('ijkl->kji', darrG)))
expect_equal(tmp38,
    as.array(einsum::einsum('ijkl->kjl', arrG)),
    as.array(einsum('ijkl->kjl', darrG)))
expect_equal(tmp39,
    as.array(einsum::einsum('ijkl->kli', arrG)),
    as.array(einsum('ijkl->kli', darrG)))
expect_equal(tmp40,
    as.array(einsum::einsum('ijkl->klj', arrG)),
    as.array(einsum('ijkl->klj', darrG)))
expect_equal(tmp41,
    as.array(einsum::einsum('ijkl->lij', arrG)),
    as.array(einsum('ijkl->lij', darrG)))
expect_equal(tmp42,
    as.array(einsum::einsum('ijkl->lik', arrG)),
    as.array(einsum('ijkl->lik', darrG)))
expect_equal(tmp43,
    as.array(einsum::einsum('ijkl->lji', arrG)),
    as.array(einsum('ijkl->lji', darrG)))
expect_equal(tmp44,
    as.array(einsum::einsum('ijkl->ljk', arrG)),
    as.array(einsum('ijkl->ljk', darrG)))
expect_equal(tmp45,
    as.array(einsum::einsum('ijkl->lki', arrG)),
    as.array(einsum('ijkl->lki', darrG)))
expect_equal(tmp46,
    as.array(einsum::einsum('ijkl->lkj', arrG)),
    as.array(einsum('ijkl->lkj', darrG)))

context("### einsum (multiply, diagonal) ###\n")
expect_equal(base::diag(arrC),
    as.vector(einsum::einsum('ii->i', arrC)),
    as.vector(einsum('ii->i', darrC)))
expect_equal(tmp47,
    as.vector(einsum::einsum('iii->i', arrE)),
    as.vector(einsum('iii->i', darrE)))
expect_equal(tmp48,
    as.vector(einsum::einsum('iiii->i', arrG)),
    as.vector(einsum('iiii->i', darrG)))

context("### einsum (sum + multiply + transpose) ###\n")
# Hadamard matrix
expect_equal(arrA*arrA,
    as.array(einsum::einsum('i,i->i', arrA, arrA)),
    as.array(einsum('i,i->i', darrA, darrA)))
expect_equal(arrD*arrD,
    as.array(einsum::einsum('ij,ij->ij', arrD, arrD)),
    as.array(einsum('ij,ij->ij', darrD, darrD)))
expect_equal(arrF*arrF,
    as.array(einsum::einsum('ijk,ijk->ijk', arrF, arrF)),
    as.array(einsum('ijk,ijk->ijk', darrF, darrF)))
expect_equal(arrG*arrG,
    as.array(einsum::einsum('ijkl,ijkl->ijkl', arrG, arrG)),
    as.array(einsum('ijkl,ijkl->ijkl', darrG, darrG)))

# Frobenius norm^2
expect_equal(sum(arrA*arrA),
    as.vector(einsum::einsum('i,i->', arrA, arrA)),
    as.vector(einsum('i,i->', darrA, darrA)))
expect_equal(sum(arrD*arrD),
    as.vector(einsum::einsum('ij,ij->', arrD, arrD)),
    as.vector(einsum('ij,ij->', darrD, darrD)))
expect_equal(sum(arrF*arrF),
    as.vector(einsum::einsum('ijk,ijk->', arrF, arrF)),
    as.vector(einsum('ijk,ijk->', darrF, darrF)))
expect_equal(sum(arrG*arrG),
    as.vector(einsum::einsum('ijkl,ijkl->', arrG, arrG)),
    as.vector(einsum('ijkl,ijkl->', darrG, darrG)))

expect_equal(sum(arrC%*%arrD),
    as.vector(einsum::einsum('ij,jk->', arrC, arrD)),
    as.vector(einsum('ij,jk->', darrC, darrD)))

expect_equal(rowSums(arrC%*%arrD),
    as.vector(einsum::einsum('ij,jk->i', arrC, arrD)),
    as.vector(einsum('ij,jk->i', darrC, darrD)))
expect_equal(tmp49,
    as.vector(einsum::einsum('ij,jk->j', arrC, arrD)),
    as.vector(einsum('ij,jk->j', darrC, darrD)))
expect_equal(colSums(arrC%*%arrD),
    as.vector(einsum::einsum('ij,jk->k', arrC, arrD)),
    as.vector(einsum('ij,jk->k', darrC, darrD)))

expect_equal(tmp50,
    as.array(einsum::einsum('ij,jk->ij', arrC, arrD)),
    as.array(einsum('ij,jk->ij', darrC, darrD)))
expect_equal(tmp51,
    as.array(einsum::einsum('ij,jk->ji', arrC, arrD)),
    as.array(einsum('ij,jk->ji', darrC, darrD)))
expect_equal(tmp52,
    as.array(einsum::einsum('ij,jk->jk', arrC, arrD)),
    as.array(einsum('ij,jk->jk', darrC, darrD)))
expect_equal(tmp53,
    as.array(einsum::einsum('ij,jk->kj', arrC, arrD)),
    as.array(einsum('ij,jk->kj', darrC, darrD)))
expect_equal(tmp54,
    as.array(einsum::einsum('ij,jk->ik', arrC, arrD)),
    as.array(einsum('ij,jk->ik', darrC, darrD)))
expect_equal(tmp55,
    as.array(einsum::einsum('ij,jk->ki', arrC, arrD)),
    as.array(einsum('ij,jk->ki', darrC, darrD)))

expect_equal(tmp56,
    as.array(einsum::einsum('ij,jk->ijk', arrC, arrD)),
    as.array(einsum('ij,jk->ijk', darrC, darrD)))
expect_equal(tmp57,
    as.array(einsum::einsum('ij,jk->ikj', arrC, arrD)),
    as.array(einsum('ij,jk->ikj', darrC, darrD)))
expect_equal(tmp58,
    as.array(einsum::einsum('ij,jk->jik', arrC, arrD)),
    as.array(einsum('ij,jk->jik', darrC, darrD)))
expect_equal(tmp59,
    as.array(einsum::einsum('ij,jk->jki', arrC, arrD)),
    as.array(einsum('ij,jk->jki', darrC, darrD)))
expect_equal(tmp60,
    as.array(einsum::einsum('ij,jk->kij', arrC, arrD)),
    as.array(einsum('ij,jk->kij', darrC, darrD)))
expect_equal(tmp61,
    as.array(einsum::einsum('ij,jk->kji', arrC, arrD)),
    as.array(einsum('ij,jk->kji', darrC, darrD)))

expect_equal(tmp62,
    as.vector(einsum::einsum('ij,ijk->', arrC, arrE)),
    as.vector(einsum('ij,ijk->', darrC, darrE)))
expect_equal(tmp63,
    as.vector(einsum::einsum('ij,ijk->i', arrC, arrE)),
    as.vector(einsum('ij,ijk->i', darrC, darrE)))
expect_equal(tmp64,
    as.vector(einsum::einsum('ij,ijk->j', arrC, arrE)),
    as.vector(einsum('ij,ijk->j', darrC, darrE)))
expect_equal(tmp65,
    as.vector(einsum::einsum('ij,ijk->k', arrC, arrE)),
    as.vector(einsum('ij,ijk->k', darrC, darrE)))
expect_equal(tmp66,
    as.array(einsum::einsum('ij,ijk->ij', arrC, arrE)),
    as.array(einsum('ij,ijk->ij', darrC, darrE)))
expect_equal(tmp67,
    as.array(einsum::einsum('ij,ijk->ji', arrC, arrE)),
    as.array(einsum('ij,ijk->ji', darrC, darrE)))
expect_equal(tmp68,
    as.array(einsum::einsum('ij,ijk->jk', arrC, arrE)),
    as.array(einsum('ij,ijk->jk', darrC, darrE)))
expect_equal(tmp69,
    as.array(einsum::einsum('ij,ijk->kj', arrC, arrE)),
    as.array(einsum('ij,ijk->kj', darrC, darrE)))
expect_equal(tmp70,
    as.array(einsum::einsum('ij,ijk->ik', arrC, arrE)),
    as.array(einsum('ij,ijk->ik', darrC, darrE)))
expect_equal(tmp71,
    as.array(einsum::einsum('ij,ijk->ki', arrC, arrE)),
    as.array(einsum('ij,ijk->ki', darrC, darrE)))
expect_equal(tmp72,
    as.array(einsum::einsum('ij,ijk->ijk', arrC, arrE)),
    as.array(einsum('ij,ijk->ijk', darrC, darrE)))

expect_equal(tmp73,
    as.vector(einsum::einsum('ijk,ijkl->', arrE, arrG)),
    as.vector(einsum('ijk,ijkl->', darrE, darrG)))
expect_equal(tmp74,
    as.vector(einsum::einsum('ijk,ijkl->i', arrE, arrG)),
    as.vector(einsum('ijk,ijkl->i', darrE, darrG)))
expect_equal(tmp75,
    as.vector(einsum::einsum('ijk,ijkl->j', arrE, arrG)),
    as.vector(einsum('ijk,ijkl->j', darrE, darrG)))
expect_equal(tmp76,
    as.vector(einsum::einsum('ijk,ijkl->k', arrE, arrG)),
    as.vector(einsum('ijk,ijkl->k', darrE, darrG)))
expect_equal(tmp77,
    as.vector(einsum::einsum('ijk,ijkl->l', arrE, arrG)),
    as.vector(einsum('ijk,ijkl->l', darrE, darrG)))
expect_equal(tmp78,
    as.array(einsum::einsum('ijk,ijkl->ij', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ij', darrE, darrG)))
expect_equal(tmp79,
    as.array(einsum::einsum('ijk,ijkl->ji', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ji', darrE, darrG)))
expect_equal(tmp80,
    as.array(einsum::einsum('ijk,ijkl->ik', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ik', darrE, darrG)))
expect_equal(tmp81,
    as.array(einsum::einsum('ijk,ijkl->ki', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ki', darrE, darrG)))
expect_equal(tmp82,
    as.array(einsum::einsum('ijk,ijkl->il', arrE, arrG)),
    as.array(einsum('ijk,ijkl->il', darrE, darrG)))
expect_equal(tmp83,
    as.array(einsum::einsum('ijk,ijkl->li', arrE, arrG)),
    as.array(einsum('ijk,ijkl->li', darrE, darrG)))
expect_equal(tmp84,
    as.array(einsum::einsum('ijk,ijkl->jk', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jk', darrE, darrG)))
expect_equal(tmp85,
    as.array(einsum::einsum('ijk,ijkl->kj', arrE, arrG)),
    as.array(einsum('ijk,ijkl->kj', darrE, darrG)))
expect_equal(tmp86,
    as.array(einsum::einsum('ijk,ijkl->jl', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jl', darrE, darrG)))
expect_equal(tmp87,
    as.array(einsum::einsum('ijk,ijkl->lj', arrE, arrG)),
    as.array(einsum('ijk,ijkl->lj', darrE, darrG)))
expect_equal(tmp88,
    as.array(einsum::einsum('ijk,ijkl->kl', arrE, arrG)),
    as.array(einsum('ijk,ijkl->kl', darrE, darrG)))
expect_equal(tmp89,
    as.array(einsum::einsum('ijk,ijkl->lk', arrE, arrG)),
    as.array(einsum('ijk,ijkl->lk', darrE, darrG)))

expect_equal(tmp90,
    as.array(einsum::einsum('ijk,ijkl->ijk', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ijk', darrE, darrG)))
expect_equal(tmp91,
    as.array(einsum::einsum('ijk,ijkl->ikj', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ikj', darrE, darrG)))
expect_equal(tmp92,
    as.array(einsum::einsum('ijk,ijkl->jik', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jik', darrE, darrG)))
expect_equal(tmp93,
    as.array(einsum::einsum('ijk,ijkl->jki', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jki', darrE, darrG)))
expect_equal(tmp94,
    as.array(einsum::einsum('ijk,ijkl->kij', arrE, arrG)),
    as.array(einsum('ijk,ijkl->kij', darrE, darrG)))
expect_equal(tmp95,
    as.array(einsum::einsum('ijk,ijkl->kji', arrE, arrG)),
    as.array(einsum('ijk,ijkl->kji', darrE, darrG)))
expect_equal(tmp96,
    as.array(einsum::einsum('ijk,ijkl->ijl', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ijl', darrE, darrG)))
expect_equal(tmp97,
    as.array(einsum::einsum('ijk,ijkl->ilj', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ilj', darrE, darrG)))
expect_equal(tmp98,
    as.array(einsum::einsum('ijk,ijkl->jil', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jil', darrE, darrG)))
expect_equal(tmp99,
    as.array(einsum::einsum('ijk,ijkl->jli', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jli', darrE, darrG)))
expect_equal(tmp100,
    as.array(einsum::einsum('ijk,ijkl->lij', arrE, arrG)),
    as.array(einsum('ijk,ijkl->lij', darrE, darrG)))
expect_equal(tmp101,
    as.array(einsum::einsum('ijk,ijkl->lji', arrE, arrG)),
    as.array(einsum('ijk,ijkl->lji', darrE, darrG)))
expect_equal(tmp102,
    as.array(einsum::einsum('ijk,ijkl->ikl', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ikl', darrE, darrG)))
expect_equal(tmp103,
    as.array(einsum::einsum('ijk,ijkl->ilk', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ilk', darrE, darrG)))
expect_equal(tmp104,
    as.array(einsum::einsum('ijk,ijkl->kil', arrE, arrG)),
    as.array(einsum('ijk,ijkl->kil', darrE, darrG)))
expect_equal(tmp105,
    as.array(einsum::einsum('ijk,ijkl->kli', arrE, arrG)),
    as.array(einsum('ijk,ijkl->kli', darrE, darrG)))
expect_equal(tmp106,
    as.array(einsum::einsum('ijk,ijkl->lik', arrE, arrG)),
    as.array(einsum('ijk,ijkl->lik', darrE, darrG)))
expect_equal(tmp107,
    as.array(einsum::einsum('ijk,ijkl->lki', arrE, arrG)),
    as.array(einsum('ijk,ijkl->lki', darrE, darrG)))
expect_equal(tmp108,
    as.array(einsum::einsum('ijk,ijkl->jkl', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jkl', darrE, darrG)))
expect_equal(tmp109,
    as.array(einsum::einsum('ijk,ijkl->jlk', arrE, arrG)),
    as.array(einsum('ijk,ijkl->jlk', darrE, darrG)))
expect_equal(tmp110,
    as.array(einsum::einsum('ijk,ijkl->kjl', arrE, arrG)),
    as.array(einsum('ijk,ijkl->kjl', darrE, darrG)))
expect_equal(tmp111,
    as.array(einsum::einsum('ijk,ijkl->klj', arrE, arrG)),
    as.array(einsum('ijk,ijkl->klj', darrE, darrG)))
expect_equal(tmp112,
    as.array(einsum::einsum('ijk,ijkl->ljk', arrE, arrG)),
    as.array(einsum('ijk,ijkl->ljk', darrE, darrG)))
expect_equal(tmp113,
    as.array(einsum::einsum('ijk,ijkl->lkj', arrE, arrG)),
    as.array(einsum('ijk,ijkl->lkj', darrE, darrG)))

context("### einsum (sum + multiply + transpose, three tensor) ###\n")
expect_equal(tmp114,
    as.vector(einsum::einsum('i,ij,ijk->', arrA, arrD, arrF)),
    as.vector(einsum('i,ij,ijk->', darrA, darrD, darrF)))
expect_equal(tmp115,
    as.vector(einsum::einsum('i,ij,ijk->i', arrA, arrD, arrF)),
    as.vector(einsum('i,ij,ijk->i', darrA, darrD, darrF)))
expect_equal(tmp116,
    as.vector(einsum::einsum('i,ij,ijk->j', arrA, arrD, arrF)),
    as.vector(einsum('i,ij,ijk->j', darrA, darrD, darrF)))
expect_equal(tmp117,
    as.vector(einsum::einsum('i,ij,ijk->k', arrA, arrD, arrF)),
    as.vector(einsum('i,ij,ijk->k', darrA, darrD, darrF)))
expect_equal(tmp118,
    as.array(einsum::einsum('i,ij,ijk->ij', arrA, arrD, arrF)),
    as.array(einsum('i,ij,ijk->ij', darrA, darrD, darrF)))
expect_equal(tmp119,
    as.array(einsum::einsum('i,ij,ijk->ik', arrA, arrD, arrF)),
    as.array(einsum('i,ij,ijk->ik', darrA, darrD, darrF)))
expect_equal(tmp120,
    as.array(einsum::einsum('i,ij,ijk->ji', arrA, arrD, arrF)),
    as.array(einsum('i,ij,ijk->ji', darrA, darrD, darrF)))
expect_equal(tmp121,
    as.array(einsum::einsum('i,ij,ijk->jk', arrA, arrD, arrF)),
    as.array(einsum('i,ij,ijk->jk', darrA, darrD, darrF)))
expect_equal(tmp122,
    as.array(einsum::einsum('i,ij,ijk->ki', arrA, arrD, arrF)),
    as.array(einsum('i,ij,ijk->ki', darrA, darrD, darrF)))
expect_equal(tmp123,
    as.array(einsum::einsum('i,ij,ijk->kj', arrA, arrD, arrF)),
    as.array(einsum('i,ij,ijk->kj', darrA, darrD, darrF)))
expect_equal(tmp124,
    as.array(einsum::einsum('i,ij,ijk->ijk', arrA, arrD, arrF)),
    as.array(einsum('i,ij,ijk->ijk', darrA, darrD, darrF)))

expect_equal(
    tmp125,
    einsum::einsum('i,ij,ijk,ijkl->ijkl', arrA, arrD, arrF, arrH),
    as.array(einsum('i,ij,ijk,ijkl->ijkl', darrA, darrD, darrF, darrH)))

# cf.
# https://www.procrasist.com/entry/einsum
# https://github.com/numpy/numpy/blob/623bc1fae1d47df24e7f1e29321d0c0ba2771ce0/numpy/typing/tests/data/pass/einsumfunc.py
# https://ajcr.net/Basic-guide-to-einsum/

setSparse <- function(as.sparse=FALSE){
    stopifnot(is.logical(as.sparse))
    options(delayedtensor.sparse = as.sparse)
    if(as.sparse){
        msg <- paste0("All functions except einsum(), outerProd(),\n",
            "and modeSum() have switched to sparse mode.\n")
        message(msg)
    }
}

getSparse <- function(){
    options("delayedtensor.sparse")
}

setVerbose <- function(as.verbose=FALSE){
    stopifnot(is.logical(as.verbose))
    options(delayedtensor.verbose = as.verbose)
}

getVerbose <- function(){
    options("delayedtensor.verbose")
}

# Setting
setAutoBlockSize(size=1E+8)
options(delayedtensor.sparse = TRUE)

test_file("testthat/test_Generics.R")
test_file("testthat/test_Misc.R")
test_file("testthat/test_Decomp.R")
test_file("testthat/test_4thorder.R")
test_file("testthat/test_Einsum.R")

options(delayedtensor.sparse = FALSE)

#
# Generic / Method Definitions
#

# unfold
setGeneric("unfold",
    function(darr, row_idx=NULL, col_idx=NULL){
        standardGeneric("unfold")})
setMethod("unfold", signature(darr="DelayedArray"),
    function(darr, row_idx=NULL, col_idx=NULL){
        .unfold(darr, row_idx, col_idx)})
.unfold <- function(darr, row_idx, col_idx){
    # Argument Check
    .checkUnfold(darr, row_idx, col_idx)
    # Setting
    num_modes <- .ndim(darr)
    perm <- c(row_idx, col_idx)
    modes <- dim(darr)
    new_modes <- as.integer(c(prod(modes[row_idx]), prod(modes[col_idx])))
    mat <- aperm(darr, perm)
    vecobj <- .realize_and_return(vec(mat))
    .reshapeIncNumbers1D(vecobj, new_modes)
}

# k_unfold
setGeneric("k_unfold",
    function(darr, m=NULL){
        standardGeneric("k_unfold")})
setMethod("k_unfold", signature(darr="DelayedArray"),
    function(darr, m=NULL){
        .k_unfold(darr, m)})
.k_unfold <- function(darr, m){
    if(is.null(m)){
        stop("mode m must be specified")
    }
    num_modes <- .ndim(darr)
    unfold(darr, row_idx=m, col_idx=seq_len(num_modes)[-m])
}

# matvec
setGeneric("matvec",
    function(darr){
        standardGeneric("matvec")})
setMethod("matvec", signature(darr="DelayedArray"),
    function(darr){
        .matvec(darr)})
.matvec <- function(darr){
    if(.ndim(darr) != 3){
        stop("Matvec currently only implemented for 3d Tensors")
    }
    unfold(darr, row_idx=c(1, 3), col_idx=2)
}

# rs_unfold
setGeneric("rs_unfold",
    function(darr, m=NULL){
        standardGeneric("rs_unfold")})
setMethod("rs_unfold", signature(darr="DelayedArray"),
    function(darr, m=NULL){
        .rs_unfold(darr, m)})
.rs_unfold <- function(darr, m){
    if(is.null(m)){
        stop("mode m must be specified")
    }
    num_modes <- .ndim(darr)
    unfold(darr, row_idx=m, col_idx=seq_len(num_modes)[-m])
}

# cs_unfold
setGeneric("cs_unfold",
    function(darr, m=NULL){
        standardGeneric("cs_unfold")})
setMethod("cs_unfold", signature(darr="DelayedArray"),
    function(darr, m=NULL){
        .cs_unfold(darr, m)})
.cs_unfold <- function(darr, m){
    if(is.null(m)){
        stop("mode m must be specified")
    }
    num_modes <- .ndim(darr)
    unfold(darr, row_idx=seq_len(num_modes)[-m], col_idx=m)
}

# modeSum
setGeneric("modeSum",
    function(darr, m=NULL, drop=FALSE){
        standardGeneric("modeSum")})
setMethod("modeSum", signature(darr="DelayedArray"),
    function(darr, m=NULL, drop=FALSE){
        .modeSum(darr, m, drop)})
.modeSum <- function(darr, m, drop){
    # Argument Check
    .checkModeSum(darr, m)
    # Setting
    num_modes <- .ndim(darr)
    perm <- c(m, (1L:num_modes)[-m])
    revperm <- rep(0, length=num_modes)
    revperm[m] <- 1
    revperm[-m] <- 2:num_modes
    block.size <- getAutoBlockSize()
    # Permutation
    darr_p <- .realize_and_return(aperm(darr, perm))
    p_new_modes <- as.integer(dim(darr_p)[2:num_modes])
    ## darr
    darr_p_spacings <- .blockSizeScheduling3(dim(darr_p), block.size)
    # e.g. 2×3×4×5 => 40 * [2,2,1,1]
    darr_p_grid <- RegularArrayGrid(
        refdim=dim(darr_p),
        spacings=darr_p_spacings)
    ## sink
    sink_grid <- RegularArrayGrid(
        refdim=c(1L, p_new_modes),
        spacings=c(1L, darr_p_spacings[2:num_modes]))
    ## check
    .checkLimit(darr_p_grid, block.size)
    .checkLimit(sink_grid, block.size)
    stopifnot(length(darr_p_grid) %% length(sink_grid) == 0)
    # Block processing
    setAutoRealizationBackend("HDF5Array")
    sink <- AutoRealizationSink(c(1L, p_new_modes))
    for(bid in seq_along(sink_grid)){
        viewport <- sink_grid[[bid]]
        block1 <- read_block(as(sink, "DelayedArray"), viewport)
        block2 <- .block_modesum(darr_p, darr_p_grid, bid)
        sink <- write_block(sink, viewport, block1 + block2)
        if(getVerbose()$delayedtensor.verbose){
            cat(paste0("\\ Processing viewport ",
                bid, "/", length(sink_grid), " ... OK\n"))
        }
    }
    close(sink)
    out <- as(sink, "DelayedArray")
    out <- .realize_and_return(aperm(out, revperm))
    if(drop){
        dif <- setdiff(seq_len(num_modes), m)
        out <- .realize_and_return(aperm(out, dif))
    }
    out
}

.block_modesum <- function(darr_p, darr_p_grid, bid){
    # sink: bid = 1,2,3,4,...,length(sink_grid)
    # darr: did = (1,2,3), (4,5,6), (7,8,9),...,(start:end)
    # Summation range
    stepsize <- dim(darr_p_grid)[1]
    start <- as.integer((bid - 1) * stepsize + 1)
    end <- as.integer(bid * stepsize)
    out <- read_block(darr_p, darr_p_grid[[start]])
    out[] <- 0
    for(did in start:end){
        out <- out + read_block(darr_p, darr_p_grid[[did]])
    }
    .block_collapse(out)
}

.block_collapse <- function(a){
    num_modes <- .ndim(a)
    commas <- paste(rep("", length=num_modes), collapse=",")
    m <- array(0, dim=c(1, dim(a)[2:num_modes]))
    cmd <- paste0("for(z in seq_len(dim(a)[[1]])){",
        "m[1", commas, "] <- ",
        "m[1", commas, "] + a[z", commas, "]}")
    eval(parse(text=cmd))
    m
}

# modeMean
setGeneric("modeMean",
    function(darr, m=NULL, drop=FALSE){
        standardGeneric("modeMean")})
setMethod("modeMean", signature(darr="DelayedArray"),
    function(darr, m=NULL, drop=FALSE){
        .modeMean(darr, m, drop)})
.modeMean <- function(darr, m, drop){
    modes <- dim(darr)
    msum <- .modeSum(darr, m, drop)
    out <- msum / modes[m]
    .realize_and_return(out)
}

# fnorm
setGeneric("fnorm",
    function(darr){
        standardGeneric("fnorm")})
setMethod("fnorm", signature(darr="DelayedArray"),
    function(darr){
        .fnorm(darr)})
.fnorm <- function(darr){
    sqrt(.innerProd(darr, darr))
}

# innerProd
setGeneric("innerProd",
    function(darr1, darr2){
        standardGeneric("innerProd")})
setMethod("innerProd", signature(darr1="DelayedArray", darr2="DelayedArray"),
    function(darr1, darr2){
        .innerProd(darr1, darr2)})
.innerProd <- function(darr1, darr2){
    stopifnot(identical(dim(darr1), dim(darr2)))
    sum(darr1 * darr2)
}

# outerProd
setGeneric("outerProd",
    function(darr1, darr2){
        standardGeneric("outerProd")})
setMethod("outerProd", signature(darr1="DelayedArray", darr2="DelayedArray"),
    function(darr1, darr2){
        .outerProd(darr1, darr2)})
.outerProd <- function(darr1, darr2){
    idx_lfs1 <- letters[seq_len(.ndim(darr1))]
    idx_lfs2 <- letters[.ndim(darr1) + seq_len(.ndim(darr2))]
    idx_rhs <- c(idx_lfs1, idx_lfs2)
    cmd <- paste0(
            paste(idx_lfs1, collapse=""),
            ",",
            paste(idx_lfs2, collapse=""),
            "->",
            paste(idx_rhs, collapse=""))
    einsum(cmd, darr1, darr2)
}

# vec
setGeneric("vec",
    function(darr){
        standardGeneric("vec")})
setMethod("vec", signature(darr="DelayedArray"),
    function(darr){
        .vec(darr)})
.vec <- function(darr){
    # Setting
    modes <- as.integer(dim(darr))
    new_modes <- as.integer(prod(dim(darr)))
    block.size <- getAutoBlockSize()
    # darr
    darr_spacings <- .blockSizeScheduling(modes, block.size)
    darr_grid <- RegularArrayGrid(
        refdim=modes,
        spacings=darr_spacings)
    # sink
    tickmarks <- unlist(gridApply(darr_grid, length))
    tickmarks <- list(as.integer(cumsum(tickmarks)))
    sink_grid <- ArbitraryArrayGrid(tickmarks = tickmarks)
    ## check
    .checkLimit(darr_grid, block.size)
    .checkLimit(sink_grid, block.size)
    stopifnot(length(darr_grid) == length(sink_grid))
    # Block processing
    setAutoRealizationBackend("HDF5Array")
    sink <- AutoRealizationSink(new_modes)
    for(bid in seq_along(sink_grid)){
        viewport <- sink_grid[[bid]]
        block <- .block_vec(darr, darr_grid, bid)
        sink <- write_block(sink, viewport, block)
        if(options()$delayedtensor.verbose){
            cat(paste0("\\ Processing viewport ",
                bid, "/", length(sink_grid), " ... OK\n"))
        }
    }
    close(sink)
    as(sink, "DelayedArray")
}

.block_vec <- function(darr, darr_grid, bid){
    if(options()$delayedtensor.sparse){
        v <- read_block(darr, darr_grid[[bid]], as.sparse=TRUE)
        as.array(SVT_SparseArray(v, dim=length(v)))
    }else{
        v <- read_block(darr, darr_grid[[bid]], as.sparse=FALSE)
        dim(v) <- prod(dim(v))
        v
    }
}

# hadamard
setGeneric("hadamard",
    function(darr1, darr2){
        standardGeneric("hadamard")})
setMethod("hadamard",
    signature(darr1="DelayedArray", darr2="DelayedArray"),
    function(darr1, darr2){
        .hadamard(darr1, darr2)})
.hadamard <- function(darr1, darr2){
    # Argument Check
    .checkHadamard(darr1, darr2)
    ## Setting
    mode1s <- as.integer(dim(darr1))
    mode2s <- as.integer(dim(darr2))
    new_modes <- mode1s
    block.size <- getAutoBlockSize()
    ## sink
    sink_spacings <- .blockSizeScheduling(new_modes, block.size)
    sink_grid <- RegularArrayGrid(
        refdim=new_modes,
        spacings=sink_spacings)
    ## check
    .checkLimit(sink_grid, block.size)
    # Block processing
    setAutoRealizationBackend("HDF5Array")
    sink <- AutoRealizationSink(new_modes)
    FUN <- function(sink_viewport, sink) {
        bid <- currentBlockId()
        block <- .block_hadamard(darr1, darr2, sink_grid, bid)
        write_block(sink, sink_viewport, block)
    }
    sink <- gridReduce(FUN, sink_grid, sink,
        verbose=options()$delayedtensor.verbose)
    close(sink)
    as(sink, "DelayedArray")
}

.block_hadamard <- function(darr1, darr2, sink_grid, bid){
    if(options()$delayedtensor.sparse){
        a <- read_block(darr1, sink_grid[[bid]], as.sparse=TRUE)
        b <- read_block(darr2, sink_grid[[bid]], as.sparse=TRUE)
        idx1 <- apply(a@nzcoo, 1, function(x){
            paste(x, collapse="-")
        })
        idx2 <- apply(b@nzcoo, 1, function(x){
            paste(x, collapse="-")
        })
        common_idx <- intersect(idx1, idx2)
        if(length(common_idx) == 0){
            .array(dim(darr1))
        }else{
            target <- vapply(common_idx, function(x){
                which(idx1 == x)
            }, 0L)
            out <- COO_SparseArray(dim(darr1))
            # Hadamard Product
            nzdata <- a@nzdata[target] * b@nzdata[target]
            if(length(common_idx) == 1){
                out@nzcoo <- t(a@nzcoo[target, ])
            }else{
                out@nzcoo <- a@nzcoo[target, ]
            }
            out@nzdata <- as.vector(nzdata)
            DelayedArray(out)
        }
    }else{
        a <- read_block(darr1, sink_grid[[bid]], as.sparse=FALSE)
        b <- read_block(darr2, sink_grid[[bid]], as.sparse=FALSE)
        # Hadamard product
        a <- as.array(a)
        b <- as.array(b)
        DelayedArray(a * b)
    }
}

# kronecker
setGeneric("kronecker",
    function(darr1, darr2){
        standardGeneric("kronecker")})
setMethod("kronecker",
    signature(darr1="DelayedArray", darr2="DelayedArray"),
    function(darr1, darr2){
        .kronecker(darr1, darr2)})
.kronecker <- function(darr1, darr2){
    # Argument Check
    .checkKronecker(darr1, darr2)
    # Setting
    mode1s <- as.integer(dim(darr1))
    mode2s <- as.integer(dim(darr2))
    new_modes <- as.integer(mode1s * mode2s)
    block.size <- getAutoBlockSize()
    ## darr2
    darr_spacings2 <- .blockSizeScheduling(mode2s, block.size)
    darr_grid_2 <- RegularArrayGrid(
        refdim=mode2s,
        spacings=darr_spacings2)
    ## darr1
    darr_spacings1 <- .blockSizeScheduling2(mode1s, mode2s, block.size)
    darr_grid_1 <- RegularArrayGrid(
        refdim=mode1s,
        spacings=darr_spacings1)
    ## sink
    tickmarks <- .tickMarksScheduling1(new_modes, darr_grid_1, darr_grid_2)
    sink_grid <- ArbitraryArrayGrid(tickmarks = tickmarks)
    block_modes <- dim(darr_grid_1) * dim(darr_grid_2)
    ## check
    .checkLimit(darr_grid_1, block.size)
    .checkLimit(darr_grid_2, block.size)
    .checkLimit(sink_grid, block.size)
    stopifnot(length(darr_grid_1) * length(darr_grid_2) ==
        length(sink_grid))
    # Block processing
    setAutoRealizationBackend("HDF5Array")
    sink <- AutoRealizationSink(new_modes)
    for(bid in seq_along(sink_grid)){
        viewport <- sink_grid[[bid]]
        block <- .block_kronecker(darr1, darr2,
            darr_grid_1, darr_grid_2, bid, block_modes)
        sink <- write_block(sink, viewport, block)
        if(options()$delayedtensor.verbose){
            cat(paste0("\\ Processing viewport ",
                bid, "/", length(sink_grid), " ... OK\n"))
        }
    }
    close(sink)
    as(sink, "DelayedArray")
}

.block_kronecker <- function(darr1, darr2, darr_grid_1, darr_grid_2,
    bid, block_modes){
    # Indexing
    idx1_idx2 <- .block_kroneckerIDX(bid, block_modes, darr_grid_1, darr_grid_2)
    idx1 <- idx1_idx2$idx1
    idx2 <- idx1_idx2$idx2
    if(options()$delayedtensor.sparse){
        new_modes <- dim(darr_grid_1[[idx1]])*dim(darr_grid_2[[idx2]])
        a <- read_block(darr1, darr_grid_1[[idx1]], as.sparse=TRUE)
        b <- read_block(darr2, darr_grid_2[[idx2]], as.sparse=TRUE)
        if(length(a@nzdata)*length(b@nzdata) == 0){
            .array(new_modes)
        }else{
            out <- COO_SparseArray(new_modes)
            nzcoo <- .kroneckerIDX(a, b)
            nzdata <- as.vector(outer(a@nzdata, b@nzdata))
            out@nzcoo <- nzcoo
            out@nzdata <- as.vector(nzdata)
            DelayedArray(out)
        }
    }else{
        a <- read_block(darr1, darr_grid_1[[idx1]], as.sparse=FALSE)
        b <- read_block(darr2, darr_grid_2[[idx2]], as.sparse=FALSE)
        a <- as.array(a)
        b <- as.array(b)
        # Kronecker product
        DelayedArray(base::kronecker(a, b))
    }
}

.block_kroneckerIDX <- function(bid, block_modes, darr_grid_1, darr_grid_2){
    Mindex <- as.vector(Lindex2Mindex(bid, block_modes))
    idx2 <- Mindex %% dim(darr_grid_2)
    zero_idx <- which(idx2 == 0)
    idx2[zero_idx] <- dim(darr_grid_2)[zero_idx]
    idx1 <- (Mindex - idx2) / dim(darr_grid_2) + 1
    idx1 <- Mindex2Lindex(idx1, dim(darr_grid_1))
    idx2 <- Mindex2Lindex(idx2, dim(darr_grid_2))
    idx1 <- as.integer(idx1)
    idx2 <- as.integer(idx2)
    list(idx1=idx1, idx2=idx2)
}

.kroneckerIDX <- function(a, b){
    idx <- apply(b@nzcoo, 1, function(x){
        x + (dim(b) * t(a@nzcoo - 1))
    })
    idx <- as.array(idx)
    dim(idx) <- c(.ndim(b), length(idx)/.ndim(b))
    t(idx)
}

# khatri_rao
setGeneric("khatri_rao",
    function(darr1, darr2){
        standardGeneric("khatri_rao")})
setMethod("khatri_rao",
    signature(darr1="DelayedArray", darr2="DelayedArray"),
    function(darr1, darr2){
        .khatri_rao(darr1, darr2)})
.khatri_rao <- function(darr1, darr2){
    # Argument Check
    .checkKhatri_Rao(darr1, darr2)
    # Setting
    mode1s <- as.integer(dim(darr1))
    mode2s <- as.integer(dim(darr2))
    new_modes <- as.integer(c(mode1s[1]*mode2s[1], mode1s[2]))
    block.size <- getAutoBlockSize()
    ## darr2
    darr_spacings2 <- .blockSizeScheduling(mode2s, block.size)
    darr_grid_2 <- RegularArrayGrid(
        refdim=dim(darr2),
        spacings=darr_spacings2)
    ## darr1
    darr_spacings1 <- .blockSizeScheduling2(mode1s, mode2s, block.size)
    darr_spacings1[2] <- darr_spacings2[2]
    darr_grid_1 <- RegularArrayGrid(
        refdim=dim(darr1),
        spacings=darr_spacings1)
    ## sink
    tickmarks <- .tickMarksScheduling2(new_modes, darr_grid_1, darr_grid_2)
    sink_grid <- ArbitraryArrayGrid(tickmarks = tickmarks)
    block_modes <- c(dim(darr_grid_1)[1] * dim(darr_grid_2)[1],
                    dim(darr_grid_1)[2])
    ## check
    .checkLimit(darr_grid_1, block.size)
    .checkLimit(darr_grid_2, block.size)
    .checkLimit(sink_grid, block.size)
    stopifnot(ncol(darr_grid_1) == ncol(sink_grid))
    stopifnot(ncol(darr_grid_2) == ncol(sink_grid))
    stopifnot(length(darr_grid_1) <= length(sink_grid))
    stopifnot(length(darr_grid_2) <= length(sink_grid))
    # Block processing
    setAutoRealizationBackend("HDF5Array")
    sink <- AutoRealizationSink(new_modes)
    for (bid in seq_along(sink_grid)) {
        viewport <- sink_grid[[bid]]
        block <- .block_khatri_rao(darr1, darr2,
            darr_grid_1, darr_grid_2, bid, block_modes)
        sink <- write_block(sink, viewport, block)
        if(options()$delayedtensor.verbose){
            cat(paste0("\\ Processing viewport ",
                bid, "/", length(sink_grid), " ... OK\n"))
        }
    }
    close(sink)
    as(sink, "DelayedArray")
}

.block_khatri_rao <- function(darr1, darr2, darr_grid_1, darr_grid_2,
    bid, block_modes){
    # Indexing
    idx1_idx2 <- .block_khatri_rao_IDX2(
        bid, block_modes, darr_grid_1, darr_grid_2)
    idx1 <- idx1_idx2$idx1
    idx2 <- idx1_idx2$idx2
    if(options()$delayedtensor.sparse){
        new_modes <- c(nrow(darr1)*nrow(darr2), ncol(darr1))
        a <- read_block(darr1, darr_grid_1[[idx1]], as.sparse=TRUE)
        b <- read_block(darr2, darr_grid_2[[idx2]], as.sparse=TRUE)
        common_cols <- unique(intersect(a@nzcoo[,2], b@nzcoo[,2]))
        check1 <- length(a@nzdata)*length(b@nzdata) == 0
        check2 <- length(common_cols) == 0
        if(check1 || check2){
            .array(new_modes)
        }else{
            out <- COO_SparseArray(new_modes)
            nzcoo <- .khatri_raoIDX(a, b, common_cols)
            nzdata <- .khatri_raoVALUE(a, b, common_cols)
            out@nzcoo <- nzcoo
            out@nzdata <- as.vector(nzdata)
            DelayedArray(out)
        }
    }else{
        a <- read_block(darr1, darr_grid_1[[idx1]], as.sparse=FALSE)
        b <- read_block(darr2, darr_grid_2[[idx2]], as.sparse=FALSE)
        stopifnot(ncol(a) == ncol(b))
        a <- as.array(a)
        b <- as.array(b)
        out <- matrix(0, nrow=nrow(a)*nrow(b), ncol=ncol(a))
        # Khatri-Rao product
        for(i in seq_len(ncol(a))){
            out[,i] <- base::kronecker(as.matrix(a[,i]), as.matrix(b[,i]))
        }
        DelayedArray(out)
    }
}

.khatri_raoIDX <- function(a, b, common_cols){
    x <- unlist(lapply(common_cols, function(xx){
        target1 <- which(a@nzcoo[,2] == xx)
        target2 <- which(b@nzcoo[,2] == xx)
        unlist(lapply(nrow(b) * (a@nzcoo[target1,1] - 1), function(xxx){
            b@nzcoo[target2,1] + xxx
        }))
    }))
    y <- unlist(lapply(common_cols, function(xx){
        target1 <- which(a@nzcoo[,2] == xx)
        target2 <- which(b@nzcoo[,2] == xx)
        rep(xx, length(target1)*length(target2))
    }))
    cbind(x, y)
}

.khatri_raoVALUE <- function(a, b, common_cols){
    unlist(lapply(common_cols, function(xx){
        target1 <- which(a@nzcoo[,2] == xx)
        target2 <- which(b@nzcoo[,2] == xx)
        as.vector(outer(b@nzdata[target2], a@nzdata[target1]))
    }))
}

.block_khatri_rao_IDX2 <- function(bid, block_modes, darr_grid_1, darr_grid_2){
    Mindex <- as.vector(Lindex2Mindex(bid, block_modes))
    idx2 <- Mindex[1] %% dim(darr_grid_2)[1]
    if(idx2 == 0){
        idx2 = dim(darr_grid_2)[1]
    }
    idx1 <- (Mindex[1] - idx2) / dim(darr_grid_2)[1] + 1
    idx1 <- Mindex2Lindex(c(idx1, Mindex[2]), dim(darr_grid_1))
    idx2 <- Mindex2Lindex(c(idx2, Mindex[2]), dim(darr_grid_2))
    idx1 <- as.integer(idx1)
    idx2 <- as.integer(idx2)
    list(idx1=idx1, idx2=idx2)
}

# fold
setGeneric("fold",
    function(mat, row_idx=NULL, col_idx=NULL, modes=NULL){
        standardGeneric("fold")})
setMethod("fold",
    signature(mat="DelayedArray"),
    function(mat, row_idx=NULL, col_idx=NULL, modes=NULL){
        .fold(mat, row_idx, col_idx, modes)})
.fold <- function(mat, row_idx, col_idx, modes){
    # Argument Check
    .checkFold(mat, row_idx, col_idx, modes)
    # Setting
    num_modes <- length(modes)
    # Reshaping
    new_modes <- as.integer(c(modes[row_idx], modes[col_idx]))
    vecobj <- .realize_and_return(vec(mat))
    sink <- .reshapeIncNumbers1D(vecobj, new_modes)
    #rearranges into array
    iperm <- match(seq_len(num_modes), c(row_idx, col_idx))
    sink <- aperm(sink, iperm)
    .realize_and_return(sink)
}

# k_fold
setGeneric("k_fold",
    function(mat, m=NULL, modes=NULL){
        standardGeneric("k_fold")})
setMethod("k_fold",
    signature(mat="DelayedArray"),
    function(mat, m=NULL, modes=NULL){
        .k_fold(mat, m, modes)})
.k_fold <- function(mat, m, modes){
    if(is.null(m)){
        stop("mode m must be specified")
    }
    if(is.null(modes)){
        stop("DelayedTensor modes must be specified")
    }
    num_modes <- length(modes)
    .fold(mat, row_idx=m, col_idx=seq_len(num_modes)[-m], modes=modes)
}

# unmatvec
setGeneric("unmatvec",
    function(mat, modes=NULL){
        standardGeneric("unmatvec")})
setMethod("unmatvec",
    signature(mat="DelayedArray"),
    function(mat, modes=NULL){
        .unmatvec(mat, modes)})
.unmatvec <- function(mat, modes){
    if(is.null(modes)){
        stop("DelayedTensor modes must be specified")
    }
    num_modes <- length(modes)
    .fold(mat, row_idx=seq_len(num_modes)[-2], col_idx=2, modes=modes)
}

# rs_fold
setGeneric("rs_fold",
    function(mat, m=NULL, modes=NULL){
        standardGeneric("rs_fold")})
setMethod("rs_fold",
    signature(mat="DelayedArray"),
    function(mat, m=NULL, modes=NULL){
        .rs_fold(mat, m, modes)})
.rs_fold <- function(mat, m, modes){
    if(is.null(m)){
        stop("mode m must be specified")
    }
    if(is.null(modes)){
        stop("DelayedTensor modes must be specified")
    }
    num_modes <- length(modes)
    .fold(mat, row_idx=m, col_idx=seq_len(num_modes)[-m], modes=modes)
}

# cs_fold
setGeneric("cs_fold",
    function(mat, m=NULL, modes=NULL){
        standardGeneric("cs_fold")})
setMethod("cs_fold",
    signature(mat="DelayedArray"),
    function(mat, m=NULL, modes=NULL){
        .cs_fold(mat, m, modes)})
.cs_fold <- function(mat, m, modes){
    if(is.null(m)){
        stop("mode m must be specified")
    }
    if(is.null(modes)){
        stop("DelayedTensor modes must be specified")
    }
    num_modes <- length(modes)
    .fold(mat, row_idx=seq_len(num_modes)[-m], col_idx=m, modes=modes)
}

# ttm
setGeneric("ttm",
    function(darr, mat, m=NULL){
        standardGeneric("ttm")})
setMethod("ttm",
    signature(darr="DelayedArray", mat="DelayedArray"),
    function(darr, mat, m=NULL){
        .ttm(darr, mat, m)})
.ttm <- function(darr, mat, m){
    # check
    mat_dims <- dim(mat)
    modes_in <- dim(darr)
    stopifnot(modes_in[m] == mat_dims[2])
    modes_out <- modes_in
    modes_out[m] <- mat_dims[1]
    darr_m <- .rs_unfold(darr, m=m)
    retarr_m <- .realize_and_return(mat %*% darr_m)
    .rs_fold(retarr_m, m=m, modes=modes_out)
}

# diag as getter
setGeneric("diag",
    function(darr){
        standardGeneric("diag")})
setMethod("diag", signature(darr="DelayedArray"),
    function(darr){
        .diag(darr)})
.diag <- function(darr){
    num_modes <- .ndim(darr)
    min.s <- min(dim(darr))
    out <- COO_SparseArray(min.s)
    cmd <- paste0("for(i in seq_len(min.s)){",
        "out@nzdata[i] <- darr[",
            paste(rep("i", length=num_modes), collapse=","), "]}")
    eval(parse(text=cmd))
    out@nzcoo <-  t(vapply(seq_len(min.s),
        function(x){rep(x, num_modes)}, rep(1L, num_modes)))
    out <- as.array(out)
    DelayedArray(out)
}

# diag as setter
setGeneric("diag<-",
    function(darr, value){
        standardGeneric("diag<-")})
setMethod("diag<-", signature(darr="DelayedArray"),
    function(darr, value){
        `diag<-`(darr, value)})
`diag<-` <- function(darr, value){
    num_modes <- .ndim(darr)
    len.i <- min(dim(darr))
    len.v <- length(value)
    if(len.i == len.v){
        cmd <- "] <- value[i]}"
    }else if(len.v == 1){
        cmd <- "] <- value}"
    }else{
        stop("replacement diagonal has wrong length")
    }
    cmd <- paste0("for(i in seq_len(len.i)){darr[",
        paste(rep("i", length=num_modes), collapse=","),
        cmd)
    eval(parse(text=cmd))
    .realize_and_return(darr)
}

# Ref
# https://github.com/rikenbit/rTensor/blob/master/R/rTensor_Class.R

# Setting
arr <- array(runif(2*3*4), dim=c(2,3,4))
tnsr <- as.tensor(arr)
darr <- DelayedArray(arr)
mat <- matrix(runif(10), nrow=5, ncol=2)
dmat <- DelayedArray(mat)

context("### unfold ###\n")
expect_equal(
    rTensor::unfold(tnsr, row_idx=1, col_idx=c(2, 3))@data,
    as.array(unfold(darr, row_idx=1, col_idx=c(2, 3))))

expect_equal(
    rTensor::unfold(tnsr, row_idx=1, col_idx=c(3, 2))@data,
    as.array(unfold(darr, row_idx=1, col_idx=c(3, 2))))

expect_equal(
    rTensor::unfold(tnsr, row_idx=2, col_idx=c(1, 3))@data,
    as.array(unfold(darr, row_idx=2, col_idx=c(1, 3))))

expect_equal(
    rTensor::unfold(tnsr, row_idx=2, col_idx=c(3, 1))@data,
    as.array(unfold(darr, row_idx=2, col_idx=c(3, 1))))

expect_equal(
    rTensor::unfold(tnsr, row_idx=3, col_idx=c(1, 2))@data,
    as.array(unfold(darr, row_idx=3, col_idx=c(1, 2))))

expect_equal(
    rTensor::unfold(tnsr, row_idx=3, col_idx=c(2, 1))@data,
    as.array(unfold(darr, row_idx=3, col_idx=c(2, 1))))

context("### k_unfold ###\n")
expect_equal(
    rTensor::k_unfold(tnsr, m=1)@data,
    as.array(k_unfold(darr, m=1)))

expect_equal(
    rTensor::k_unfold(tnsr, m=2)@data,
    as.array(k_unfold(darr, m=2)))

expect_equal(
    rTensor::k_unfold(tnsr, m=3)@data,
    as.array(k_unfold(darr, m=3)))

context("### matvec ###\n")
expect_equal(
    rTensor::matvec(tnsr)@data,
    as.array(matvec(darr)))

context("### rs_unfold ###\n")
expect_equal(
    rTensor::rs_unfold(tnsr, m=1)@data,
    as.array(rs_unfold(darr, m=1)))

expect_equal(
    rTensor::rs_unfold(tnsr, m=2)@data,
    as.array(rs_unfold(darr, m=2)))

expect_equal(
    rTensor::rs_unfold(tnsr, m=3)@data,
    as.array(rs_unfold(darr, m=3)))

context("### cs_unfold ###\n")
expect_equal(
    rTensor::cs_unfold(tnsr, m=1)@data,
    as.array(cs_unfold(darr, m=1)))

expect_equal(
    rTensor::cs_unfold(tnsr, m=2)@data,
    as.array(cs_unfold(darr, m=2)))

expect_equal(
    rTensor::cs_unfold(tnsr, m=3)@data,
    as.array(cs_unfold(darr, m=3)))

context("### modeSum ###\n")
expect_equal(
    rTensor::modeSum(tnsr, m=1, drop=FALSE)@data,
    as.array(modeSum(darr, m=1, drop=FALSE)))

expect_equal(
    rTensor::modeSum(tnsr, m=2, drop=FALSE)@data,
    as.array(modeSum(darr, m=2, drop=FALSE)))

expect_equal(
    rTensor::modeSum(tnsr, m=3, drop=FALSE)@data,
    as.array(modeSum(darr, m=3, drop=FALSE)))

expect_equal(
    rTensor::modeSum(tnsr, m=1, drop=TRUE)@data,
    as.array(modeSum(darr, m=1, drop=TRUE)))

expect_equal(
    rTensor::modeSum(tnsr, m=2, drop=TRUE)@data,
    as.array(modeSum(darr, m=2, drop=TRUE)))

expect_equal(
    rTensor::modeSum(tnsr, m=3, drop=TRUE)@data,
    as.array(modeSum(darr, m=3, drop=TRUE)))

context("### modeMean ###\n")
expect_equal(
    rTensor::modeMean(tnsr, m=1, drop=FALSE)@data,
    as.array(modeMean(darr, m=1, drop=FALSE)))

expect_equal(
    rTensor::modeMean(tnsr, m=2, drop=FALSE)@data,
    as.array(modeMean(darr, m=2, drop=FALSE)))

expect_equal(
    rTensor::modeMean(tnsr, m=3, drop=FALSE)@data,
    as.array(modeMean(darr, m=3, drop=FALSE)))

expect_equal(
    rTensor::modeMean(tnsr, m=1, drop=TRUE)@data,
    as.array(modeMean(darr, m=1, drop=TRUE)))

expect_equal(
    rTensor::modeMean(tnsr, m=2, drop=TRUE)@data,
    as.array(modeMean(darr, m=2, drop=TRUE)))

expect_equal(
    rTensor::modeMean(tnsr, m=3, drop=TRUE)@data,
    as.array(modeMean(darr, m=3, drop=TRUE)))

context("### fnorm ###\n")
expect_equal(
    rTensor::fnorm(tnsr),
    fnorm(darr))

context("### innerProd ###\n")
expect_equal(
    rTensor::innerProd(tnsr, tnsr),
    innerProd(darr, darr))

context("### outerProd ###\n")
expect_equal(
    dim(outerProd(darr, darr)),
    c(dim(darr), dim(darr)))

context("### vec ###\n")
expect_equal(
	as.vector(rTensor::vec(tnsr)),
	as.vector(vec(darr)))

context("### hadamard ###\n")
expect_equal(
    tnsr@data * tnsr@data,
    as.array(hadamard(darr, darr)))

context("### kronecker ###\n")
expect_equal(
    base::kronecker(tnsr@data, tnsr@data),
    as.array(kronecker(darr, darr)))

context("### khatri_rao ###\n")
expect_equal(
    rTensor::khatri_rao(tnsr@data[,,1], tnsr@data[,,1]),
    as.array(khatri_rao(darr[,,1], darr[,,1])))

context("### fold ###\n")
tnsr2 <- rTensor::fold(
    rTensor::unfold(tnsr, row_idx=2, col_idx=c(3,1))@data,
    row_idx=2, col_idx=c(3,1), modes=c(2,3,4))
darr2 <- fold(unfold(darr, row_idx=2, col_idx=c(3,1)),
    row_idx=2, col_idx=c(3,1), modes=c(2,3,4))
expect_equal(
    tnsr@data,
    tnsr2@data,
    as.array(darr2))

context("### k_fold ###\n")
expect_equal(
    rTensor::k_fold(rTensor::k_unfold(tnsr, m=2)@data, m=2, modes=c(2,3,4))@data,
    tnsr@data,
    as.array(k_fold(k_unfold(darr, m=2), m=2, modes=c(2,3,4))))

context("### unmatvec ###\n")
expect_equal(
    rTensor::unmatvec(rTensor::matvec(tnsr)@data, modes=c(2,3,4))@data,
    tnsr@data,
    as.array(unmatvec(matvec(darr), modes=c(2,3,4))))

context("### rs_fold ###\n")
expect_equal(
    rTensor::rs_fold(rTensor::rs_unfold(tnsr, m=2)@data, m=2, modes=c(2,3,4))@data,
    tnsr@data,
    as.array(rs_fold(rs_unfold(darr, m=2), m=2, modes=c(2,3,4))))

context("### cs_fold ###\n")
expect_equal(
    rTensor::cs_fold(rTensor::cs_unfold(tnsr, m=3)@data, m=3, modes=c(2,3,4))@data,
    tnsr@data,
    as.array(cs_fold(cs_unfold(darr, m=3), m=3, modes=c(2,3,4))))

context("### ttm ###\n")
expect_equal(
    rTensor::ttm(tnsr, mat, m=1)@data,
    as.array(ttm(darr, dmat, m=1)))

context("### diag (getter) ###\n")
expect_equal(
    c(arr[1,1,1], arr[2,2,2]),
    as.vector(diag(darr)))

context("### diag<- (setter) ###\n")
arr[1,1,1] <- 111
arr[2,2,2] <- 222
diag(darr) <- c(111 ,222)
expect_equal(
    c(arr[1,1,1], arr[2,2,2]),
    as.vector(diag(darr)))

\docType{methods}
\name{modeSum-methods}
\alias{modeSum-methods}
\alias{modeSum}
\alias{modeSum,DelayedArray-method}
\title{Tensor Sum Across Single Mode of DelayedArray}
\usage{
modeSum(darr, m = NULL, drop = FALSE)

\S4method{modeSum}{DelayedArray}(darr, m, drop)
}
\arguments{
\item{darr}{DelayedArray object}

\item{m}{the index of the mode to sum across}

\item{drop}{whether or not mode m should be dropped}
}
\value{
K-1 or K tensor, where \code{K = length(dim(darr))}
}
\description{
Given a mode for a K-tensor, this returns the K-1 tensor resulting from
summing across that particular mode.
}
\details{
This function is an extension of the \code{\link[rTensor]{modeSum}}
by DelayedArray.

NOTE: Sparse mode of modeSum is not available for now.

\code{modeSum(darr, m=NULL, drop=FALSE)}
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(1,2,3))
modeSum(darr, 1, drop=FALSE)
modeSum(darr, 1, drop=TRUE)
modeSum(darr, 2)
modeSum(darr, 3)
}
\seealso{
\code{\link{modeMean}}
}

\name{rbind_list}
\alias{rbind_list}
\title{Mode-binding against list}
\usage{
rbind_list(L)
}
\arguments{
\item{L}{list of 2D DelayedArray}
}
\value{
2D DelayedArray object
}
\description{
Returns the binded DelayedArray in row space.
}
\details{
This is a wrapper function to \code{\link{modebind_list}},
when the DelayedArrays are 2D.
}
\note{
The dimensions of row in each DelayedArray must match.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
dlizt <- list(
    'darr1' = RandomUnifArray(c(2,3)),
    'darr2' = RandomUnifArray(c(2,3)))
rbind_list(dlizt)
}
\seealso{
\code{\link{modebind_list}}
}

\name{getVerbose}
\alias{getVerbose}
\title{Getter function to control the verbose messages from DelayedTensor}
\usage{
getVerbose()
}
\value{
TRUE or FALSE (Default: FALSE)
}
\description{
Returns the verbose setting of DelayedTensor functions.
}
\examples{
getVerbose()
}

\name{getSparse}
\alias{getSparse}
\title{Getter of the intermediate/output DelayedArray object in DelayedTensor}
\usage{
getSparse()
}
\value{
TRUE or FALSE (Default: FALSE)
}
\description{
Whether the intermediate and output DelayedArray used in DelayedTensor
is used as sparse tensor or not.

NOTE: Sparse mode is experimental! Whether it contributes to higher speed and
lower memory is quite dependent on the sparsity of the DelayedArray,
and the current implementation does not recognize the block size,
which may cause Out-of-Memory errors.
}
\examples{
getSparse()
}

\name{khatri_rao_list}
\alias{khatri_rao_list}
\title{Khatri-Rao Product against list}
\usage{
khatri_rao_list(L, reverse = FALSE)
}
\arguments{
\item{L}{list of DelayedArray}

\item{reverse}{whether or not to reverse the order}
}
\value{
matrix that is the Khatri-Rao product
}
\description{
Returns the Khatri-Rao product from a list of matrices or vectors.
Commonly used for n-mode products and various Tensor decompositions.
}
\note{
The number of columns must match in every element of the input list.
}
\details{
This function is an extension of the \code{\link[rTensor]{khatri_rao_list}}
by DelayedArray.
}
\examples{
library("DelayedRandomArray")
darr1 <- RandomUnifArray(c(2,3))
dlizt <- list(
    'darr1' = RandomUnifArray(c(2,4)),
    'darr2' = RandomUnifArray(c(3,4)))
khatri_rao_list(dlizt)
}
\seealso{
\code{\link{hadamard}}, \code{\link{hadamard_list}},
\code{\link{kronecker}}, \code{\link{kronecker_list}},
\code{\link{khatri_rao}}
}

\docType{methods}
\name{cs_fold-methods}
\alias{cs_fold-methods}
\alias{cs_fold}
\alias{cs_fold,DelayedArray-method}
\title{Column Space Folding of 2D DelayedArray}
\usage{
cs_fold(mat, m = NULL, modes = NULL)

\S4method{cs_fold}{DelayedArray}(mat, m, modes)
}
\arguments{
\item{mat}{DelayedArray object (only 2D)}

\item{m}{the mode corresponding to cs_unfold}

\item{modes}{the original modes of the DelayedArray}
}
\value{
DelayedArray (higher than 2D)
}
\description{
The inverse operation to \code{\link{cs_unfold}}.
}
\details{
This function is an extension of the \code{\link[rTensor]{cs_fold}}
by DelayedArray.

This is a wrapper function to \code{\link{fold}}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
matT3 <- DelayedTensor::cs_unfold(darr, m=3)
identical(
    as.array(DelayedTensor::cs_fold(matT3, m=3, modes=c(2,3,4))),
    as.array(darr))
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{fold}}, \code{\link{cs_unfold}}
}

\docType{methods}
\name{mpca-methods}
\alias{mpca-methods}
\alias{mpca}
\alias{mpca,DelayedArray-method}
\title{Multilinear Principal Components Analysis}
\usage{
mpca(darr, ranks=NULL, max_iter=25, tol=1e-05)

\S4method{mpca}{DelayedArray}(darr, ranks, max_iter, tol)
}
\arguments{
\item{darr}{Tensor with K modes}

\item{ranks}{a vector of the compressed modes of the output core Tensor,
this has length K-1}

\item{max_iter}{maximum number of iterations if error stays above \code{tol}}

\item{tol}{relative Frobenius norm error tolerance}
}
\value{
a list containing the following:\describe{
\item{\code{Z_ext}}{the extended core tensor,
with the first K-1 modes given by \code{ranks}}
\item{\code{U}}{a list of K-1 orthgonal factor matrices -
one for each compressed mode, with the number of columns
of the matrices given by \code{ranks}}
\item{\code{conv}}{whether or not \code{resid} < \code{tol}
by the last iteration}
\item{\code{est}}{estimate of \code{darr} after compression}
\item{\code{norm_percent}}{the percent of Frobenius norm
explained by the approximation}
\item{\code{fnorm_resid}}{the Frobenius norm of the error
\code{fnorm(est-darr)}}
\item{\code{all_resids}}{vector containing the Frobenius norm of error
for all the iterations}
}
}
\description{
This is basically the Tucker decomposition of a K-Tensor,
\code{\link{tucker}}, with one of the modes uncompressed.
If K = 3, then this is also known as the Generalized Low Rank Approximation
of Matrices (GLRAM). This implementation assumes that the last mode is the
measurement mode and hence uncompressed. This is an iterative algorithm,
with two possible stopping conditions:
either relative error in Frobenius norm has gotten below \code{tol},
or the \code{max_iter} number of iterations has been reached.
For more details on the MPCA of tensors, consult Lu et al. (2008).
}
\details{
This function is an extension of the \code{\link[rTensor]{mpca}}
by DelayedArray.

Uses the Alternating Least Squares (ALS) estimation procedure.
A progress bar is included to help monitor operations on large tensors.
}
\note{
The length of \code{ranks} must match \code{darr@num_modes-1}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(3,4,5))
mpca(darr, ranks=c(1,2))
}
\references{
H. Lu, K. Plataniotis, A. Venetsanopoulos,
"Mpca: Multilinear principal component analysis of tensor objects".
IEEE Trans. Neural networks, 2008.
}
\seealso{
\code{\link{tucker}}, \code{\link{hosvd}}
}

\name{kronecker_list}
\alias{kronecker_list}
\title{Kronecker Product against list}
\usage{
kronecker_list(L)
}
\arguments{
\item{L}{list of DelayedArray}
}
\value{
matrix that is the Kronecker product
}
\description{
Returns the Kronecker product from a list of matrices or vectors.
Commonly used for n-mode products and various Tensor decompositions.
}
\details{
This function is an extension of the \code{\link[rTensor]{kronecker_list}}
by DelayedArray.
}
\examples{
library("DelayedRandomArray")
dlizt <- list(
    'darr1' = RandomUnifArray(c(2,3,4)),
    'darr2' = RandomUnifArray(c(2,3,4)))
kronecker_list(dlizt)
}
\seealso{
\code{\link{khatri_rao}}, \code{\link{khatri_rao_list}},
\code{\link{hadamard}}, \code{\link{hadamard_list}},
\code{\link{kronecker}}
}

\docType{methods}
\name{rs_unfold-methods}
\alias{rs_unfold-methods}
\alias{rs_unfold}
\alias{rs_unfold,DelayedArray-method}
\title{Tensor Row Space Unfolding of DelayedArray}
\usage{
rs_unfold(darr, m)

\S4method{rs_unfold}{DelayedArray}(darr, m)
}
\arguments{
\item{darr}{DelayedArray object}

\item{m}{mode to be unfolded on}
}
\value{
DelayedArray (2D)
}
\description{
Please see \code{\link{k_unfold}} and \code{\link{unfold}}.
}
\details{
This function is an extension of the \code{\link[rTensor]{rs_unfold}}
by DelayedArray.

This is a wrapper function to \code{\link{unfold}}.

See also \code{rs_unfold(darr, m=NULL)}
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
matT2 <- rs_unfold(darr, m=2)
}
\seealso{
\code{\link{unfold}}, \code{\link{rs_fold}}
}

\name{DelayedTensor-package}
\alias{DelayedTensor-package}
\alias{DelayedTensor}
\docType{package}
\title{
\packageTitle{DelayedTensor}
}
\description{
\packageDescription{DelayedTensor}
}
\details{

The DESCRIPTION file:
\packageDESCRIPTION{DelayedTensor}
\packageIndices{DelayedTensor}
}
\author{
\packageAuthor{DelayedTensor}

Maintainer: \packageMaintainer{DelayedTensor}
}
\keyword{ package }
\seealso{
# Unfold operations
\code{\link{unfold}}, \code{\link{k_unfold}}, \code{\link{matvec}},
\code{\link{rs_unfold}}, \code{\link{cs_unfold}}, \code{\link{ttl}}
# Fold operations
\code{\link{fold}}, \code{\link{k_fold}}, \code{\link{unmatvec}},
\code{\link{rs_fold}}, \code{\link{cs_fold}}, \code{\link{ttm}}
# Vectorization
\code{\link{vec}}
# Norm operations
\code{\link{fnorm}}, \code{\link{innerProd}}
# Diagonal operations / Diagonal Tensor
\code{\link{diag}}, \code{\link{DelayedDiagonalArray}}
# Mode-wise operations
\code{\link{modeSum}}, \code{\link{modeMean}}
# Tensor product operations
\code{\link{hadamard}}, \code{\link{hadamard_list}},
\code{\link{kronecker}}, \code{\link{kronecker_list}},
\code{\link{khatri_rao}}, \code{\link{khatri_rao_list}}
# Utilities
\code{\link{list_rep}}, \code{\link{modebind_list}},
\code{\link{rbind_list}}, \code{\link{cbind_list}}
# Decomposition operations
\code{\link{hosvd}}, \code{\link{cp}}, \code{\link{tucker}},
\code{\link{mpca}}, \code{\link{pvd}}
# Einsum operation
\code{\link{einsum}}
}
\examples{
ls("package:DelayedTensor")
}

\docType{methods}
\name{k_fold-methods}
\alias{k_fold-methods}
\alias{k_fold}
\alias{k_fold,DelayedArray-method}
\title{k-mode Folding  of 2D DelayedArray}
\usage{
k_fold(mat, m = NULL, modes = NULL)

\S4method{k_fold}{DelayedArray}(mat, m, modes)
}
\arguments{
\item{mat}{DelayedArray object (only 2D)}

\item{m}{the index of the mode that is mapped onto the row indices}

\item{modes}{the modes of the output DelayedArray}
}
\value{
DelayedArray object with modes given by \code{modes}
}
\description{
k-mode folding of a matrix into a Tensor. This is the inverse funtion
to \code{k_unfold} in the m mode. In particular,
\code{k_fold(k_unfold(darr, m), m, dim(darr))}
will result in the original Tensor.
}
\details{
This function is an extension of the \code{\link[rTensor]{k_fold}}
by DelayedArray.

This is a wrapper function to \code{\link{fold}}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
matT2 <- k_unfold(darr, m=2)
identical(
    as.array(k_fold(matT2, m=2, modes=c(2,3,4))),
    as.array(darr))
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{fold}}, \code{\link{k_unfold}}
}

\docType{methods}
\name{unfold-methods}
\alias{unfold-methods}
\alias{unfold}
\alias{unfold,DelayedArray-method}
\title{Tensor Unfolding of 2D DelayedArray}
\usage{
unfold(darr, row_idx, col_idx)

\S4method{unfold}{DelayedArray}(darr, row_idx, col_idx)
}
\arguments{
\item{darr}{DelayedArray object}

\item{row_idx}{the indices of the modes to map onto the row space}

\item{col_idx}{the indices of the modes to map onto the column space}
}
\value{
2D DelayedArray with \code{prod(row_idx)} rows and \code{prod(col_idx)} columns
}
\description{
Unfolds the tensor into a matrix, with the modes in \code{rs} onto the rows
and modes in \code{cs} onto the columns. Note that \code{c(rs,cs)}
must have the same elements (order doesn't matter) as \code{dim(darr)}.
Within the rows and columns, the order of the unfolding is determined
by the order of the modes.
This convention is consistent with Kolda and Bader (2009).
}
\details{
This function is an extension of the \code{\link[rTensor]{unfold}}
by DelayedArray.

For Row Space Unfolding or m-mode Unfolding,
see \code{\link{rs_unfold}}.
For Column Space Unfolding or matvec,
see \code{\link{cs_unfold}}.

\code{\link{vec}} returns the vectorization of the tensor.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
unfold(darr, row_idx=2, col_idx=c(3,1))
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{k_unfold}}, \code{\link{matvec}},
\code{\link{rs_unfold}}, \code{\link{cs_unfold}}
}

\docType{methods}
\name{cs_unfold-methods}
\alias{cs_unfold-methods}
\alias{cs_unfold}
\alias{cs_unfold,DelayedArray-method}
\title{Tensor Column Space Unfolding of DelayedArray}
\usage{
cs_unfold(darr, m)

\S4method{cs_unfold}{DelayedArray}(darr, m)
}
\arguments{
\item{darr}{DelayedArray object}

\item{m}{mode to be unfolded on}
}
\value{
DelayedArray (2D)
}
\description{
Please see \code{\link{matvec}} and \code{\link{unfold}}.
}
\details{
This function is an extension of the \code{\link[rTensor]{cs_unfold}}
by DelayedArray.

This is a wrapper function to \code{\link{unfold}}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
DelayedTensor::cs_unfold(darr, m=3)
}
\seealso{
\code{\link{unfold}}, \code{\link{cs_fold}}
}

\name{einsum}
\alias{einsum}
\title{Einstein Summation of DelayedArray}
\usage{
einsum(subscripts, ...)
}
\arguments{
\item{subscripts}{
a string in Einstein notation where arrays
are separated by ',' and the result is separated by '->'. For
example \code{"ij,jk->ik"} corresponds to a standard matrix multiplication.
Whitespace inside the \code{subscripts} is ignored. Unlike the
equivalent functions in Python, \code{einsum} only supports the explicit
mode. This means that the \code{subscripts} must contain '->'.}

\item{...}{the DelayedArrays that are combined.}
}
\value{
The \code{einsum} function returns an array with one dimension for each index
in the result of the \code{subscripts}.
For example \code{"ij,jk->ik"} produces a 2-dimensional array,
\code{"abc,cd,de->abe"} produces a 3-dimensional array.
}
\description{
Einstein summation is a convenient and concise notation for operations
on n-dimensional arrays.

NOTE: Sparse mode of einsum is not available for now.
}
\details{
This function is an extension of the \code{\link[einsum]{einsum}}
by DelayedArray.
}
\examples{
library("DelayedArray")
library("DelayedRandomArray")
darr1 <- RandomUnifArray(c(4,8))
darr2 <- RandomUnifArray(c(8,3))

# Matrix Multiply
darr1 \%*\% darr2
DelayedTensor::einsum("ij,jk -> ik", darr1, darr2)

# Diag
mat_sq <- RandomUnifArray(c(4,4))
DelayedTensor::diag(mat_sq)
einsum("ii->i", mat_sq)

# Trace
sum(DelayedTensor::diag(mat_sq))
einsum("ii->", mat_sq)

# Scalar product
darr3 <- RandomUnifArray(c(4,8))
darr3 * darr1
einsum("ij,ij->ij", darr3, darr1)

# Transpose
t(darr1)
einsum("ij->ji", darr1)

# Batched L2 norm
arr1 <- as.array(darr1)
arr3 <- as.array(darr3)
darr4 <- DelayedArray(array(c(arr1, arr3), dim = c(dim(arr1), 2)))

c(sum(darr1^2), sum(darr3^2))
einsum("ijb,ijb->b", darr4, darr4)
}

\name{mouse_mid_brain}
\alias{mouse_mid_brain}
\docType{data}
\title{Matrix object of mouse mid brain data}
\description{
A matrix with 500 rows (genes) * 1907 columns (cells).
}
\usage{data(mouse_mid_brain)}
\details{
The data matrix is downloaded from GEO Series GSE76381
(https://www.ncbi.nlm.nih.gov/geo/download/?acc=GSE76381&format=file).
% For saving the package size, the number of genes are strictlly reduced by the
% thresholding based on the variances of genes.
For the details, see inst/script/make-data.R.
}
\references{
Y-h. Taguchi and T. Turki (2019)
Tensor Decomposition-Based Unsupervised Feature Extraction Applied to
Single-Cell Gene Expression Analysis.
\emph{Frontiers in Genetics}, \bold{10(864)}: 10:3389/fgene.2019.00864
}
\examples{
data(mouse_mid_brain)
}
\seealso{
\code{\link{mouse_mid_brain}}
}
\keyword{datasets}

\docType{methods}
\name{modeMean-methods}
\alias{modeMean-methods}
\alias{modeMean}
\alias{modeMean,DelayedArray-method}
\title{Tensor Mean Across Single Mode of DelayedArray}
\usage{
modeMean(darr, m = NULL, drop = FALSE)

\S4method{modeMean}{DelayedArray}(darr, m, drop)
}
\arguments{
\item{darr}{DelayedArray object}

\item{m}{the index of the mode to average across}

\item{drop}{whether or not mode m should be dropped}
}
\value{
K-1 or K Tensor, where \code{K = length(dim(darr))}
}
\description{
Given a mode for a K-tensor, this returns the K-1 tensor resulting from
taking the mean across that particular mode.
}
\details{
This function is an extension of the \code{\link[rTensor]{modeMean}}
by DelayedArray.

NOTE: Sparse mode of modeMean is not available for now.

\code{modeMean(darr, m=NULL, drop=FALSE)}
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(1,2,3))
modeMean(darr, 1, drop=FALSE)
modeMean(darr, 1, drop=TRUE)
modeMean(darr, 2)
modeMean(darr, 3)
}
\seealso{
\code{\link{modeSum}}
}

\name{list_rep}
\alias{list_rep}
\title{Replicate of arbitrary object}
\usage{
list_rep(x, n=NULL)
}
\arguments{
\item{x}{Any object}

\item{n}{Number of replicate}
}
\value{
List
}
\description{
Returns the replicates of base obejct \code{x}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
list_rep(darr, 3)
}

\docType{methods}
\name{kronecker-methods}
\alias{kronecker-methods}
\alias{kronecker}
\alias{kronecker,DelayedArray,DelayedArray-method}
\title{Kronecker Product of DelayedArray}
\usage{
kronecker(darr1, darr2)

\S4method{kronecker}{DelayedArray,DelayedArray}(darr1, darr2)
}
\arguments{
\item{darr1}{first DelayedArray object}

\item{darr2}{second DelayedArray object}
}
\value{
matrix that is the Kronecker product
}
\description{
Returns the Kronecker product of two Tensors.
Commonly used for n-mode products and various Tensor decompositions.
}
\examples{
library("DelayedRandomArray")
darr1 <- RandomUnifArray(c(2,3))
darr2 <- RandomUnifArray(c(4,5))
kronecker(darr1, darr2)
}
\seealso{
\code{\link{khatri_rao}}, \code{\link{khatri_rao_list}},
\code{\link{hadamard}}, \code{\link{hadamard_list}},
\code{\link{kronecker_list}}
}

\docType{methods}
\name{fnorm-methods}
\alias{fnorm-methods}
\alias{fnorm}
\alias{fnorm,DelayedArray-method}
\title{Tensor Frobenius Norm of DelayedArray}
\usage{
fnorm(darr)

\S4method{fnorm}{DelayedArray}(darr)
}
\arguments{
\item{darr}{DelayedArray object}
}
\value{
numeric Frobenius norm of \code{darr}
}
\description{
Returns the Frobenius norm of the Tensor instance.
}
\details{
This function is an extension of the \code{\link[rTensor]{fnorm}}
by DelayedArray.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
fnorm(darr)
}

\name{hadamard_list}
\alias{hadamard_list}
\title{Hadamard Product against list}
\usage{
hadamard_list(L)
}
\arguments{
\item{L}{list of DelayedArray}
}
\value{
matrix that is the Hadamard product
}
\description{
Returns the hadamard (element-wise) product from a list of matrices or vectors.
Commonly used for n-mode products and various Tensor decompositions.
}
\details{
This function is an extension of the \code{\link[rTensor]{hadamard_list}}
by DelayedArray.
}
\note{
The modes/dimensions of each element in the list must match.
}
\examples{
library("DelayedRandomArray")
dlizt <- list(
    'darr1' = RandomUnifArray(c(2,3,4)),
    'darr2' = RandomUnifArray(c(2,3,4)))
hadamard_list(dlizt)
}
\seealso{
\code{\link{khatri_rao}}, \code{\link{khatri_rao_list}},
\code{\link{kronecker}}, \code{\link{kronecker_list}},
\code{\link{hadamard}}
}

\docType{methods}
\name{unmatvec-methods}
\alias{unmatvec-methods}
\alias{unmatvec}
\alias{unmatvec,DelayedArray-method}
\title{Unmatvec Folding of 2D DelayedArray}
\usage{
unmatvec(mat, modes = NULL)

\S4method{unmatvec}{DelayedArray}(mat, modes)
}
\arguments{
\item{mat}{DelayedArray object (only 2D)}

\item{modes}{the modes of the output DelayedArray}
}
\value{
DelayedArray object with modes given by \code{modes}
}
\description{
The inverse operation to \code{\link{matvec-methods}},
turning a matrix into a Tensor. For a full account of matrix
folding/unfolding operations, consult Kolda and Bader (2009).
}
\details{
This function is an extension of the \code{\link[rTensor]{unmatvec}}
by DelayedArray.

This is a wrapper function to \code{\link{fold}}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
matT1 <- matvec(darr)
identical(
    as.array(unmatvec(matT1, modes=c(2,3,4))),
    as.array(darr))
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{fold}}, \code{\link{matvec}}
}

\name{ttl}
\alias{ttl}
\title{DelayedArray Times List}
\usage{
ttl(darr, list_mat, ms=NULL)
}
\arguments{
\item{darr}{DelayedArray object with K modes}

\item{list_mat}{a list of 2D DelayedArray objects}

\item{ms}{a vector of modes to contract on
(order should match the order of \code{list_mat})}
}
\value{
DelayedArray object with K modes (Tensor)
}
\description{
Contracted (m-Mode) product between a Tensor of arbitrary number of modes
and a list of matrices. The result is folded back into Tensor.
}
\details{
This function is an extension of the \code{\link[rTensor]{ttl}}
by DelayedArray.

This is a wrapper function to \code{\link{unfold}}.

Performs \code{ttm} repeated for a single Tensor and
a list of matrices on multiple modes. For instance,
suppose we want to do multiply a Tensor object \code{darr} with
three matrices \code{mat1}, \code{mat2}, \code{mat3} on modes 1, 2, and 3.
We could do \code{ttm(ttm(ttm(darr,mat1,1),mat2,2),3)},
or we could do \code{ttl(darr,list(mat1,mat2,mat3),c(1,2,3))}.
The order of the matrices in the list should obviously match
the order of the modes.
This is a common operation for various Tensor decompositions
such as CP and Tucker.
For the math on the m-Mode Product, see Kolda and Bader (2009).
}
\note{
The returned Tensor does not drop any modes equal to 1.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(3,4,5))
dlizt <- list(
    'darr1' = RandomUnifArray(c(10,3)),
    'darr2' = RandomUnifArray(c(10,4)))
ttl(darr, dlizt, ms=c(1,2))
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{ttm}}
}

\docType{methods}
\name{cp-methods}
\alias{cp-methods}
\alias{cp}
\alias{cp,DelayedArray-method}
\title{Canonical Polyadic Decomposition}
\usage{
cp(darr, num_components=NULL, max_iter=25, tol=1e-05)

\S4method{cp}{DelayedArray}(darr, num_components, max_iter, tol)
}
\arguments{
\item{darr}{Tensor with K modes}

\item{num_components}{the number of rank-1 K-Tensors to use in approximation}

\item{max_iter}{maximum number of iterations if error stays above \code{tol}}

\item{tol}{relative Frobenius norm error tolerance}
}
\value{
a list containing the following \describe{
\item{\code{lambdas}}{a vector of normalizing constants, one for each component}
\item{\code{U}}{a list of matrices - one for each mode -
each matrix with \code{num_components} columns}
\item{\code{conv}}{whether or not \code{resid} < \code{tol}
by the last iteration}
\item{\code{norm_percent}}{the percent of Frobenius norm explained
by the approximation}
\item{\code{est}}{estimate of \code{darr} after compression}
\item{\code{fnorm_resid}}{the Frobenius norm of the error
\code{fnorm(est-darr)}}
\item{\code{all_resids}}{vector containing the Frobenius
norm of error for all the iterations}
}
}
\description{
Canonical Polyadic (CP) decomposition of a tensor, aka CANDECOMP/PARAFRAC.
Approximate a K-Tensor using a sum of \code{num_components} rank-1 K-Tensors.
A rank-1 K-Tensor can be written as an outer product of K vectors.
There are a total of \code{num_compoents *darr@num_modes} vectors in the output,
stored in \code{darr@num_modes} matrices,
each with \code{num_components} columns.
This is an iterative algorithm, with two possible stopping conditions:
either relative error in Frobenius norm has gotten below \code{tol},
or the \code{max_iter} number of iterations has been reached.
For more details on CP decomposition, consult Kolda and Bader (2009).
}
\details{
This function is an extension of the \code{\link[rTensor]{cp}}
by DelayedArray.

Uses the Alternating Least Squares (ALS) estimation procedure.
A progress bar is included to help monitor operations on large tensors.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(3,4,5))
cp(darr, num_components=2)
}
\references{
T. Kolda, B. Bader,
"Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{tucker}}
}

\docType{methods}
\name{matvec-methods}
\alias{matvec-methods}
\alias{matvec}
\alias{matvec,DelayedArray-method}
\title{Tensor Matvec Unfolding of DelayedArray}
\usage{
matvec(darr)

\S4method{matvec}{DelayedArray}(darr)
}
\arguments{
\item{darr}{DelayedArray object}
}
\value{
matrix with \code{prod(dim(darr)[-m])} rows and \code{dim(darr)[m]} columns
}
\description{
For 3-tensors only.
Stacks the slices along the third mode.
}
\details{
This function is an extension of the \code{\link[rTensor]{matvec}}
by DelayedArray.

This is a wrapper function to \code{\link{unfold}}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
matvec(darr)
}
\references{
M. Kilmer, K. Braman, N. Hao, and R. Hoover,
"Third-order tensors as operators on matrices: a theoretical and
computational framework with applications in imaging".
SIAM Journal on Matrix Analysis and Applications 2013.
}
\seealso{
\code{\link{unfold}}, \code{\link{unmatvec}}
}

\docType{methods}
\name{hosvd-methods}
\alias{hosvd-methods}
\alias{hosvd}
\alias{hosvd,DelayedArray-method}
\title{(Truncated-)Higher-order SVD}
\usage{
hosvd(darr, ranks=NULL)

\S4method{hosvd}{DelayedArray}(darr, ranks)
}
\arguments{
\item{darr}{Tensor with K modes}

\item{ranks}{a vector of desired modes in the output core tensor,
default is \code{darr@modes}}
}
\value{
a list containing the following:\describe{
\item{\code{Z}}{core tensor with modes speficied by \code{ranks}}
\item{\code{U}}{a list of orthogonal matrices, one for each mode}
\item{\code{est}}{estimate of \code{darr} after compression}
\item{\code{fnorm_resid}}{the Frobenius norm of the error
\code{fnorm(est-darr)} - if there was no truncation,
then this is on the order of mach_eps * fnorm. }
}
}
\description{
Higher-order SVD of a K-Tensor.
Write the K-Tensor as a (m-mode) product of a core Tensor
(possibly smaller modes) and K orthogonal factor matrices.
Truncations can be specified via \code{ranks}
(making them smaller than the original modes of the K-Tensor will
result in a truncation).
For the mathematical details on HOSVD, consult Lathauwer et. al. (2000).
}
\details{
This function is an extension of the \code{\link[rTensor]{hosvd}}
by DelayedArray.

A progress bar is included to help monitor operations on large tensors.
}
\note{
The length of \code{ranks} must match \code{darr@num_modes}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(3,4,5))
hosvd(darr, ranks=c(2,1,3))
}
\references{
L. Lathauwer, B.Moor, J. Vanderwalle
"A multilinear singular value decomposition".
Journal of Matrix Analysis and Applications 2000.
}
\seealso{
\code{\link{tucker}}
}

\docType{methods}
\name{outerProd-methods}
\alias{outerProd-methods}
\alias{outerProd}
\alias{outerProd,DelayedArray,DelayedArray-method}
\title{Tensors Outer Product of DelayedArray}
\usage{
outerProd(darr1, darr2)

\S4method{outerProd}{DelayedArray,DelayedArray}(darr1, darr2)
}
\arguments{
\item{darr1}{first DelayedArray object}

\item{darr2}{second DelayedArray object}
}
\value{
outer product between \code{darr1} and \code{darr2}
}
\description{
Returns the outer product between two Tensors
}
\details{
NOTE: Sparse mode of outerProd is not available for now.
}
\examples{
library("DelayedRandomArray")
darr1 <- RandomUnifArray(c(2,3))
darr2 <- RandomUnifArray(c(4,5))
outerProd(darr1, darr2)
}

\name{setVerbose}
\alias{setVerbose}
\title{Setter to set the verbose mode of DelayedTensor}
\usage{
setVerbose(as.verbose=FALSE)
}
\arguments{
\item{as.verbose}{TRUE or FALSE (Default: FALSE)}
}
\value{Nothing}
\description{
Set the verbose message to monitor the block-processing procedure.
}
\examples{
setVerbose(TRUE)
setVerbose(FALSE)
}

\docType{methods}
\name{ttm-methods}
\alias{ttm-methods}
\alias{ttm}
\alias{ttm,DelayedArray,DelayedArray-method}
\title{Tensor Times Matrix (m-Mode Product)}
\usage{
ttm(darr, mat, m = NULL)

\S4method{ttm}{DelayedArray,DelayedArray}(darr, mat, m)
}
\arguments{
\item{darr}{DelayedArray object}

\item{mat}{input 2D DelayedArray with same number columns as
the \code{m}th mode of \code{darr}}

\item{m}{the mode to contract on}
}
\value{
a DelayedArray object with K modes
}
\description{
Contracted (m-Mode) product between a DelayedArray (Tensor)
of arbitrary number of modes and a matrix.
The result is folded back into Tensor.
}
\details{
This function is an extension of the \code{\link[rTensor]{ttm}}
by DelayedArray.

By definition, \code{rs_unfold(ttm(darr, mat), m) = mat\%*\%rs_unfold(darr, m)},
so the number of columns in \code{mat} must match the
\code{m}th mode of \code{darr}. For the math on the m-Mode Product,
see Kolda and Bader (2009).
}
\note{
The \code{m}th mode of \code{darr} must match the number of columns in
\code{mat}. By default, the returned Tensor does not drop any modes equal to 1.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
mat <- RandomUnifArray(c(10,4))
ttm(darr, mat, m=3)
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{rs_unfold}}, \code{\link{ttl}}
}

\docType{methods}
\name{tucker-methods}
\alias{tucker-methods}
\alias{tucker}
\alias{tucker,DelayedArray-method}
\title{Tucker Decomposition}
\usage{
tucker(darr, ranks=NULL, max_iter=25, tol=1e-05)

\S4method{tucker}{DelayedArray}(darr, ranks, max_iter, tol)
}
\arguments{
\item{darr}{Tensor with K modes}

\item{ranks}{a vector of the modes of the output core Tensor}

\item{max_iter}{maximum number of iterations if error stays above \code{tol}}

\item{tol}{relative Frobenius norm error tolerance}
}
\value{
a list containing the following:\describe{
\item{\code{Z}}{the core tensor, with modes specified by \code{ranks}}
\item{\code{U}}{a list of orthgonal factor matrices - one for each mode,
with the number of columns of the matrices given by \code{ranks}}
\item{\code{conv}}{whether or not \code{resid} < \code{tol}
by the last iteration}
\item{\code{est}}{estimate of \code{darr} after compression}
\item{\code{norm_percent}}{the percent of Frobenius norm explained
by the approximation}
\item{\code{fnorm_resid}}{the Frobenius norm of the error
\code{fnorm(est-darr)}}
\item{\code{all_resids}}{vector containing the Frobenius norm of error
for all the iterations}
}
}
\description{
The Tucker decomposition of a tensor. Approximates a K-Tensor using a
n-mode product of a core tensor (with modes specified by \code{ranks})
with orthogonal factor matrices. If there is no truncation in one of the modes,
then this is the same as the MPCA, \code{\link{mpca}}.
If there is no truncation in all the modes (i.e. \code{ranks = darr@modes}),
then this is the same as the HOSVD, \code{\link{hosvd}}.
This is an iterative algorithm, with two possible stopping conditions:
either relative error in Frobenius norm has gotten below \code{tol},
or the \code{max_iter} number of iterations has been reached.
For more details on the Tucker decomposition, consult Kolda and Bader (2009).
}
\details{
This function is an extension of the \code{\link[rTensor]{tucker}}
by DelayedArray.

Uses the Alternating Least Squares (ALS) estimation procedure also
known as Higher-Order Orthogonal Iteration (HOOI).
Intialized using a (Truncated-)HOSVD.
A progress bar is included to help monitor operations on large tensors.
}
\note{
The length of \code{ranks} must match \code{darr@num_modes}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
tucker(darr, ranks=c(1,2,3))
}
\references{
T. Kolda, B. Bader,
"Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{hosvd}}, \code{\link{mpca}}
}

\docType{methods}
\name{k_unfold-methods}
\alias{k_unfold-methods}
\alias{k_unfold}
\alias{k_unfold,DelayedArray-method}
\title{Tensor k-mode Unfolding of DelayedArray}
\usage{
k_unfold(darr, m)

\S4method{k_unfold}{DelayedArray}(darr, m)
}
\arguments{
\item{darr}{DelayedArray object}

\item{m}{the index of the mode to unfold on}
}
\value{
matrix with \code{dim(darr)[m]} rows and \code{prod(dim(darr)[-m])} columns
}
\description{
Unfolding of a tensor by mapping the kth mode
(specified through parameter \code{m}),
and all other modes onto the column space.
This the most common type of unfolding operation for
Tucker decompositions and its variants.
Also known as k-mode matricization.
}
\details{
This function is an extension of the \code{\link[rTensor]{k_unfold}}
by DelayedArray.

This is a wrapper function to \code{\link{unfold}}.

See also \code{k_unfold(darr, m=NULL)}
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
rs_unfold(darr, m=2)
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{unfold}}, \code{\link{k_fold}}
}

\name{modebind_list}
\alias{modebind_list}
\title{Mode-binding against list}
\usage{
modebind_list(L, m=NULL)
}
\arguments{
\item{L}{list of DelayedArray}

\item{m}{list of DelayedArray}
}
\value{
DelayedArray object
}
\description{
Returns the binded DelayedArray in mode-\code{m}.
}
\note{
The dimensions of mode \code{m} must match.
}
\examples{
library("DelayedRandomArray")
dlizt <- list(
    'darr1' = RandomUnifArray(c(2,3,4)),
    'darr2' = RandomUnifArray(c(2,3,4)))
modebind_list(dlizt, m=1)
modebind_list(dlizt, m=2)
modebind_list(dlizt, m=3)
}
\seealso{
\code{\link{rbind_list}}, \code{\link{cbind_list}}
}

\docType{methods}
\name{hadamard-methods}
\alias{hadamard-methods}
\alias{hadamard}
\alias{hadamard,DelayedArray,DelayedArray-method}
\title{Hadamard Product of DelayedArray}
\usage{
hadamard(darr1, darr2)

\S4method{hadamard}{DelayedArray,DelayedArray}(darr1, darr2)
}
\arguments{
\item{darr1}{first DelayedArray object}

\item{darr2}{second DelayedArray object}
}
\value{
matrix that is the Hadamard product
}
\description{
Returns the Hadamard product of two Tensors.
Commonly used for n-mode products and various Tensor decompositions.
}
\note{
The modes/dimensions of each element of two Tensors must match.
}
\examples{
library("DelayedRandomArray")
darr1 <- RandomUnifArray(c(2,4))
darr2 <- RandomUnifArray(c(2,4))
hadamard(darr1, darr1)
}
\seealso{
\code{\link{khatri_rao}}, \code{\link{khatri_rao_list}},
\code{\link{kronecker}}, \code{\link{kronecker_list}},
\code{\link{hadamard_list}}
}

\docType{methods}
\name{vec-methods}
\alias{vec-methods}
\alias{vec}
\alias{vec,DelayedArray-method}
\title{Tensor Vectorization of DelayedArray}
\usage{
vec(darr)

\S4method{vec}{DelayedArray}(darr)
}
\arguments{
\item{darr}{DelayedArray object}
}
\value{
1D DelayedArray (vector) with length \code{prod(dim(darr))}
}
\description{
Change the dimension of DelayedArray from multi-dimension (e.g. array) to
single-dimension (e.g. vector).
}
\details{
This function is an extension of the \code{\link[rTensor]{vec}}
by DelayedArray.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
vec(darr)
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}

\docType{methods}
\name{innerProd-methods}
\alias{innerProd-methods}
\alias{innerProd}
\alias{innerProd,DelayedArray,DelayedArray-method}
\title{Tensors Inner Product of DelayedArray}
\usage{
innerProd(darr1, darr2)

\S4method{innerProd}{DelayedArray,DelayedArray}(darr1, darr2)
}
\arguments{
\item{darr1}{first DelayedArray object}

\item{darr2}{second DelayedArray object}
}
\value{
inner product between \code{darr1} and \code{darr2}
}
\description{
Returns the inner product between two Tensors
}
\details{
This function is an extension of the \code{\link[rTensor]{innerProd}}
by DelayedArray.
}
\examples{
library("DelayedRandomArray")
darr1 <- RandomUnifArray(c(2,3,4))
darr2 <- RandomUnifArray(c(2,3,4))
innerProd(darr1, darr2)
}

\docType{methods}
\name{rs_fold-methods}
\alias{rs_fold-methods}
\alias{rs_fold}
\alias{rs_fold,DelayedArray-method}
\title{Row Space Folding of 2D DelayedArray}
\usage{
rs_fold(mat, m = NULL, modes = NULL)

\S4method{rs_fold}{DelayedArray}(mat, m, modes)
}
\arguments{
\item{mat}{DelayedArray object (only 2D)}

\item{m}{the mode corresponding to rs_unfold}

\item{modes}{the original modes of the DelayedArray}
}
\value{
DelayedArray (higher than 2D)
}
\description{
The inverse operation to \code{\link{rs_unfold}}.
}
\details{
This function is an extension of the \code{\link[rTensor]{rs_fold}}
by DelayedArray.

This is a wrapper function to \code{\link{fold}}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
matT2 <- rs_unfold(darr, m=2)
identical(
    as.array(rs_fold(matT2, m=2, modes=c(2,3,4))),
    as.array(darr))
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{fold}}, \code{\link{rs_unfold}}
}

\docType{methods}
\name{diag-methods}
\alias{diag-methods}
\alias{diag}
\alias{diag<-}
\alias{diag,DelayedArray-method}
\alias{diag<-,DelayedArray-method}
\title{DelayedArray Diagonals}
\usage{
diag(darr)
diag(darr) <- value

\S4method{diag}{DelayedArray}(darr)
\S4method{diag}{DelayedArray}(darr) <- value
}
\arguments{
\item{darr}{DelayedArray object}

\item{value}{either a single value or a vector of length equal to that
    of the current diagonal. Should be of a mode which can be coerced
    to that of \code{darr}.}
}
\value{
1D DelayedArray (vector) with length \code{min(dim(darr))}
}
\description{
Extract or replace the diagonal of a DelayedArray,
or substitute the elements to the diagonal DelayedArray.
}
\details{
See also \code{\link{DelayedDiagonalArray}} or \code{\link[base]{diag}}.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
DelayedTensor::diag(darr)
DelayedTensor::diag(darr)[1] <- 11111
DelayedTensor::diag(darr)[2] <- 22222
DelayedTensor::diag(darr)
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{DelayedDiagonalArray}}
}

\name{cbind_list}
\alias{cbind_list}
\title{Mode-binding against list}
\usage{
cbind_list(L)
}
\arguments{
\item{L}{list of 2D DelayedArray}
}
\value{
2D DelayedArray object
}
\description{
Returns the binded DelayedArray in column space.
}
\details{
This is a wrapper function to \code{\link{modebind_list}},
when the DelayedArrays are 2D.
}
\note{
The dimensions of column in each DelayedArray must match.
}
\examples{
library("DelayedRandomArray")
dlizt <- list(
    'darr1' = RandomUnifArray(c(2,3)),
    'darr2' = RandomUnifArray(c(2,3)))
cbind_list(dlizt)
}
\seealso{
\code{\link{modebind_list}}
}

\name{setSparse}
\alias{setSparse}
\title{Setter to set the intermediate DelayedArray object in DelayedTensor}
\usage{
setSparse(as.sparse=FALSE)
}
\arguments{
\item{as.sparse}{TRUE or FALSE (Default: FALSE)}
}
\value{Nothing}
\description{
Set whether the intermediate and output DelayedArray used in DelayedTensor
is used as sparse tensor or not.

NOTE: Sparse mode is experimental! Whether it contributes to higher speed and
lower memory is quite dependent on the sparsity of the DelayedArray,
and the current implementation does not recognize the block size,
which may cause Out-of-Memory errors.
}
\examples{
setSparse(TRUE)
setSparse(FALSE)
}

\name{DelayedDiagonalArray}
\alias{DelayedDiagonalArray}
\title{Diagonal DelayedArray}
\usage{
DelayedDiagonalArray(shape, value)
}
\arguments{
\item{shape}{Shape of DelayedArray (mode of Tensor)}

\item{value}{either a single value or a vector. This argument is optional.
If nothing is specified, 1s are filled with each diagonal element.}
}
\value{
DelayedArray object
}
\description{
Constructor of the diagonal of a DelayedArray.
}
\details{
See also \code{\link{diag}} or \code{\link[base]{diag}}.
}
\examples{
darr <- DelayedDiagonalArray(2:4, 5)
DelayedTensor::diag(darr)
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{diag}}, \code{\link[base]{diag}}
}

\docType{methods}
\name{khatri_rao-methods}
\alias{khatri_rao-methods}
\alias{khatri_rao}
\alias{khatri_rao,DelayedArray,DelayedArray-method}
\title{Khatri-Rao Product of DelayedArray}
\usage{
khatri_rao(darr1, darr2)

\S4method{khatri_rao}{DelayedArray,DelayedArray}(darr1, darr2)
}
\arguments{
\item{darr1}{first DelayedArray object}

\item{darr2}{second DelayedArray object}
}
\value{
matrix that is the Khatri-Rao product
}
\description{
Returns the Khatri-Rao (column-wise Kronecker) product of two matrices.
If the inputs are vectors then this is the same as the Kronecker product.
}
\note{
The number of columns must match in the two inputs.
}
\details{
This function is an extension of the \code{\link[rTensor]{khatri_rao}}
by DelayedArray.
}
\examples{
library("DelayedRandomArray")
darr1 <- RandomUnifArray(c(2,4))
darr2 <- RandomUnifArray(c(3,4))
khatri_rao(darr1, darr2)
}
\seealso{
\code{\link{hadamard}}, \code{\link{hadamard_list}},
\code{\link{kronecker}}, \code{\link{kronecker_list}},
\code{\link{khatri_rao_list}}
}

\docType{methods}
\name{pvd-methods}
\alias{pvd-methods}
\alias{pvd}
\alias{pvd,DelayedArray-method}
\title{Population Value Decomposition}
\usage{
pvd(darr, uranks=NULL, wranks=NULL, a=NULL, b=NULL)

\S4method{pvd}{DelayedArray}(darr, uranks, wranks, a, b)
}
\arguments{
\item{darr}{3D DelayedArray (Tensor) with the third mode
being the measurement mode}

\item{uranks}{ranks of the U matrices}

\item{wranks}{ranks of the W matrices}

\item{a}{rank of \code{P = U\%*\%t(U)}}

\item{b}{rank of \code{D = W\%*\%t(W)}}
}
\value{
a list containing the following:\describe{
\item{\code{P}}{population-level matrix \code{P = U\%*\%t(U)},
where U is constructed by stacking the truncated left eigenvectors
of slicewise PCA along the third mode}
\item{\code{V}}{a list of image-level core matrices}
\item{\code{D}}{population-leve matrix \code{D = W\%*\%t(W)},
where W is constructed by stacking the truncated right eigenvectors
of slicewise PCA along the third mode}
\item{\code{est}}{estimate of \code{darr} after compression}
\item{\code{norm_percent}}{
the percent of Frobenius norm explained by the approximation}
\item{\code{fnorm_resid}}{
the Frobenius norm of the error \code{fnorm(est-darr)}}
}
}
\description{
The default Population Value Decomposition (PVD) of a series of 2D images.
Constructs population-level matrices P, V, and D to account for variances
within as well as across the images. Structurally similar to Tucker
(\code{\link{tucker}}) and GLRAM (\code{\link{mpca}}),
but retains crucial differences. Requires \code{2*n3 + 2} parameters to
specified the final ranks of P, V, and D, where n3 is the third mode
(how many images are in the set). Consult Crainiceanu et al. (2013)
for the construction and rationale behind the PVD model.
}
\details{
This function is an extension of the \code{\link[rTensor]{pvd}}
by DelayedArray.

The PVD is not an iterative method, but instead relies on \code{n3 + 2}
separate PCA decompositions.
The third mode is for how many images are in the set.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(3,4,5))
pvd(darr, uranks=rep(2,5), wranks=rep(3,5), a=2, b=3)
}
\references{
C. Crainiceanu, B. Caffo, S. Luo, V. Zipunnikov, N. Punjabi,
"Population value decomposition:
a framework for the analysis of image populations".
Journal of the American Statistical Association, 2013.
}

\docType{methods}
\name{fold-methods}
\alias{fold-methods}
\alias{fold}
\alias{fold,DelayedArray-method}
\title{Tensor folding of 2D DelayedArray}
\usage{
fold(mat, row_idx = NULL, col_idx = NULL, modes = NULL)

\S4method{fold}{DelayedArray}(mat, row_idx, col_idx, modes)
}
\arguments{
\item{mat}{DelayedArray object (only 2D)}

\item{row_idx}{the indices of the modes that are mapped onto the row space}

\item{col_idx}{the indices of the modes that are mapped onto the column space}

\item{modes}{the modes of the output DelayedArray}
}
\value{
DelayedArray object with modes given by \code{modes}
}
\description{
General folding of a 2D DelayedArray into a higher-order DelayedArray(Tensor).
This is designed to be the inverse function to
\code{\link{unfold}}, with the same ordering of the indices.
This amounts to following: if we were to unfold a Tensor using a set of
\code{row_idx} and \code{col_idx}, then we can fold the resulting matrix
back into the original Tensor using the same \code{row_idx} and \code{col_idx}.
}
\details{
This function is an extension of the \code{\link[rTensor]{fold}}
by DelayedArray.
}
\examples{
library("DelayedRandomArray")
darr <- RandomUnifArray(c(2,3,4))
matT3 <- DelayedTensor::unfold(darr, row_idx=2, col_idx=c(3,1))
identical(
    as.array(DelayedTensor::fold(matT3, row_idx=2,col_idx=c(3,1),
        modes=c(2,3,4))),
    as.array(darr))
}
\references{
T. Kolda, B. Bader, "Tensor decomposition and applications".
SIAM Applied Mathematics and Applications 2009.
}
\seealso{
\code{\link{unfold}}, \code{\link{k_fold}},
\code{\link{unmatvec}},
\code{\link{rs_fold}}, \code{\link{cs_fold}}
}
